c This file contains the following subroutines
c        H+ -> tau(+) + neu(tau)
c        subroutine Delta_CHtaunuEW(MHp,MFp,awidth,ilevel)
c        input: charged Higgs mass=Mhp, tau mass=Mfp, ilevel=1 tree,2 loop
c        output: awidth

c        H+ -> chargino^+(iin) + neutralino(jin)
c        subroutine Delta_CHchaneuEW(MHp,MX1,MX2,iin,jin,awidth,ischeme,ilevel)
c        input: charged Higgs mass=Mhp, chargino mass=MX1, neutralino mass=MX2
c               ilevel=1 tree,2 loop
c        output: awidth

c        H+ -> top + bottom
c        subroutine Delta_CHtb(MHp,MFin,MFpin,rmf,rmfp,awidth,ilevel)
c        input: charged Higgs mass=Mhp, top mass=Mt, bottom mass=mb
c               ilevel=1 tree,2 loop EW, 3 loop QCD, 4 EW+QCD
c        output: awidth
c Author: Dao Thi Nhung
c last update: 10/4/2020
c#define details
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        subroutine Delta_CHtb(MHp,MFin,MFpin,rmf,rmfp,awidth,ilevel)
        implicit none 
        integer ilevel,ischeme
        double precision MHp,MFin,MFpin,MF,MFp,rmf,rmfp,awidth,p
        integer I6G4,I6G5,I6G6,I2G4,I2G5,I3G4,I5G4,I5G5,
     -          I2G3,I3G3,I5G3,I6G3,I3G5

        double precision Qs
        double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
        double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
        double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
        double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
        double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
        double precision ZH5(5,5),ZH(6,6)    
        double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

        common /scale/ Qs 
        common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
        common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
        common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
        common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
        common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
        common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

        double precision absM3, phiM3
        common /gluino/ absM3,phiM3

        double precision MCH2,MF2,MFP2,realPart,FBI(0:3,0:3,0:3,0:3),
     &                   treepart,RPhaseSpace2,virtQCD,virtEW,mA,
     &                   MFF,MFF2, abry1,abry2,divergence,dMH6(6,6)
        double complex part1,IC,CTERMS,tree,treeC,
     &                 CTERMS1,CTERMS2,part2, treeL,treeR
        double complex int1,int2,int3,int4,int5(6,6),int6(6,6),int7(6,6),dZCH,dZCHW,SelfCHW,
     &                 SelfHpWm,deltambQCD,deltambEW,deltab1
        double complex aint1,aint2,aint3,aint4(6),aint5,aint6(2,6),
     -  aint7(5,6),aint8,aint9,aint10,aint11,aint12,aint13,aint14,aint15,
     -  aint16,aint17,aint18,aint19,aint20,aint21,aint22,aint23,aint24,
     -  aint25,aint26,aint27,aint28,aint29,aint30,aint31,aint32,aint33,
     -  aint34,aint35,aint36,aint37,aint38(6),aint39(6),aint40(6),
     -  aint41(6),aint42(6),aint43(6),aint44(6),aint45(6),aint46(6),
     -  aint47(6,2),aint48(6,2),aint49(6,2),aint50(6,2),aint51(6,2),
     -  aint52(6,2),aint53(2,5,6),aint54(2,5,6),aint55(2,5,6),
     -  aint56(2,5,6),aint57(2,5,6),aint58(2,5,6),aint59(5,6,6),
     -  aint60(5,6,6),aint61(5,6,6)
        double precision dmt1,dmb1,dZtL1,dZtR1,dZbL1,dZbR1,MGL,MGL2,CTREE,CLOOP,
     &                   mtsave,mbsave
        double precision g3Q,mtQ,vQ,mhQ,asDR,g1Q,g2Q,mbDR,mtDR,mbMS,deltab,T_HDEC
        logical MHpmInput,CPcon,mQrun,phasetest,onelswitch 
        common /switch/ MHpmInput,CPcon,mQrun,onelswitch
        double complex nZU(6,6),nZD(6,6)
        double precision nMSu(6),nMSd(6)
        common /nSu/ nMSu,nZU
        common /nSd/ nMSd,nZD
        double precision RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0(3), absAd0(3), absAe0(3),  
     &                 ml20(3), mer20(3), mq20(3), mdr20(3), mur20(3),
     &                 phiAu0(3), phiAd0(3), phiAe0(3)
        common/slhaDRpara/RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0, absAd0, absAe0,  
     &                 ml20, mer20, mq20, mdr20, mur20,phiAu0,phiAd0,phiAe0
        double precision RAl,RAk
        common /slhapara/ RAl,RAk
       double precision mbb,mtt
#include "looptools.h"  
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"



c        MTt=141.81D0
c        MBb=2.33D0
c        MassHpm(2)=1355D0
c        print*, "C0",C0i(cc0,MassHpm(2)**2,MTt**2,MBb**2,0D0,MassHpm(2)**2,MbB**2)
c        print*, MtT,MBb,MassHpm(2), getmudim()
c        stop

        call dmb_EWcnmssm(deltambQCD,deltambEW,deltab1,tanb)

        deltab=(deltambQCD+deltambEW)/(1+deltab1)
        IC=(0,1D0)
        MGL= absM3
        MGL2=MGL**2
        ! mF= MFin; MfP=MFpin pole masses we donot obtain UV and IR finite
        ! rmf,rmfp are also not used in the code, the same reason as above 
        MF=rmf
        mfp=rmfp   !using QCD running masses in the OS scheme for EW, SUSYQCD correction
        mtsave=mt; mbsave=mb
        mt=MF; mb=mfp   !change the stop/sbottom masses
        Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
        Yd(3) = mb*sqrt(2d0)/v/Cos(beta) 
        call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)
        call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
        call couplings
        call couplingsXX
          
        
        MF2=MF**2
		MFF=MF
		MFF2=MF**2
        MFp2=MFp**2
        MCH2=MHpm**2
        awidth=0D0
c        if(abs(MF-MFin).gt.1D0)then
c         ischeme=2 !DR scheme
c        else
        ischeme=1  ! alway use OS scheme for EW, SUSYQCD correction
c        endif

        RPhaseSpace2=sqrt(MCH2**2+MF**4+MFP**4
     &   -2D0*MCH2*MF**2-2D0*MCH2*MFP**2-2D0*MF**2*MFP**2)/16D0/pi/MHPm**3

        treeL= CtbHpL(3,3,2)
        treeR= CtbHpR(3,3,2)

        Ctree=3*DBLE(-2D0*MF*MFP*TreeL*DCONJG(TreeR)
     &   -2D0*MF*MFP*TreeR*DCONJG(TreeL)+
     &   (MCH2-MF**2-MFP**2)*(TreeL*DCONJG(TreeL)+TreeR*DCONJG(TreeR)))
             
        treepart=RPhaseSpace2*Ctree

      if(ilevel.ge.3)then ! SUSY-QCD correction
c if:  ischeme=1 for OS scheme; otherwise for DRbar scheme
        if (ischeme.eq.1)then
       dmt1=0D0           !SM-QCD has been removed


           do I6G3 = 1,6
       dmt1=dmt1+(g3**2*(DBLE(B0i(bb1,MF2,MSu2(I6G3),MGL**2))*
     &  (CF15usuL(3,I6G3)*DCONJG(CF15usuL(3,I6G3))+CF15usuR(3,I6G3)*
     &  DCONJG(CF15usuR(3,I6G3)))*MFF+DBLE(B0i(bb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(CF15usuL(3,I6G3)*(-(MGL*DCONJG(CF15usuR(3,I6G3)
     &  ))+DCONJG(CF15usuL(3,I6G3))*MFF)+CF15usuR(3,I6G3)*(-(MGL*
     &  DCONJG(CF15usuL(3,I6G3)))+DCONJG(CF15usuR(3,I6G3))*MFF)))
     &  )/(24d0*Pi**2)
           enddo
        else
       dmt1=0D0
        endif
c if:  ischeme=1 for OS scheme; otherwise for DRbar scheme
        if (ischeme.eq.1)then
       dmb1=0D0            !SM-QCD has been removed

           do I6G3 = 1,6
       dmb1=dmb1+(g3**2*(DBLE(B0i(bb1,MFp2,MSd2(I6G3),MGL**2))*
     &  (CF15dsdL(3,I6G3)*DCONJG(CF15dsdL(3,I6G3))+CF15dsdR(3,I6G3)*
     &  DCONJG(CF15dsdR(3,I6G3)))*MFp+DBLE(B0i(bb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(CF15dsdL(3,I6G3)*(-(MGL*DCONJG(CF15dsdR(3,I6G3)
     &  ))+DCONJG(CF15dsdL(3,I6G3))*MFp)+CF15dsdR(3,I6G3)*(-(MGL*
     &  DCONJG(CF15dsdL(3,I6G3)))+DCONJG(CF15dsdR(3,I6G3))*MFp)))
     &  )/(24d0*Pi**2)
           enddo
        else
       dmb1=0D0
        endif
c endif: ischeme=1 for OS scheme; ischeme!=1 for DRbar scheme
       ! WFRs for top and bottom are always in OS scheme 
       dZbL1=0D0              !SM-QCD has been removed


           do I6G3 = 1,6
       dZbL1=dZbL1+(g3**2*(CF15dsdR(3,I6G3)*(MGL*DBLE(B0i(bb0,MFp2,MGL*
     &  *2,MSd2(I6G3)))*DCONJG(CF15dsdL(3,I6G3))-2*(MFp2*
     &  DBLE(B0i(dbb1,MFp2,MSd2(I6G3),MGL**2))*DCONJG(CF15dsdR(3,I6G3))
     &  *MFp+DBLE(B0i(dbb0,MFp2,MGL**2,MSd2(I6G3)))*(MFp2*
     &  DCONJG(CF15dsdR(3,I6G3))*MFp-MGL*DCONJG(CF15dsdL(3,I6G3))
     &  *MFp2)))-CF15dsdL(3,I6G3)*(DBLE(B0i(bb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(MGL*DCONJG(CF15dsdR(3,I6G3))+2*
     &  DCONJG(CF15dsdL(3,I6G3))*MFp)+2*
     &  (DBLE(B0i(bb1,MFp2,MSd2(I6G3),MGL**2))*DCONJG(CF15dsdL(3,I6G3))
     &  *MFp+MFp2*DBLE(B0i(dbb1,MFp2,MSd2(I6G3),MGL**2))*
     &  DCONJG(CF15dsdL(3,I6G3))*MFp+DBLE(B0i(dbb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(MFp2*DCONJG(CF15dsdL(3,I6G3))*MFp-MGL*
     &  DCONJG(CF15dsdR(3,I6G3))*MFp2)))))/(24d0*Pi**2*MFp)
           enddo

       dZbR1=0D0         !SM-QCD has been removed

           do I6G3 = 1,6
       dZbR1=dZbR1-(g3**2*(CF15dsdR(3,I6G3)*(DBLE(B0i(bb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(MGL*DCONJG(CF15dsdL(3,I6G3))+2*
     &  DCONJG(CF15dsdR(3,I6G3))*MFp)+2*
     &  (DBLE(B0i(bb1,MFp2,MSd2(I6G3),MGL**2))*DCONJG(CF15dsdR(3,I6G3))
     &  *MFp+MFp2*DBLE(B0i(dbb1,MFp2,MSd2(I6G3),MGL**2))*
     &  DCONJG(CF15dsdR(3,I6G3))*MFp+DBLE(B0i(dbb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(MFp2*DCONJG(CF15dsdR(3,I6G3))*MFp-MGL*
     &  DCONJG(CF15dsdL(3,I6G3))*MFp2)))+CF15dsdL(3,I6G3)*(-(MGL*
     &  DBLE(B0i(bb0,MFp2,MGL**2,MSd2(I6G3)))*DCONJG(CF15dsdR(3,I6G3)))
     &  +2*(MFp2*DBLE(B0i(dbb1,MFp2,MSd2(I6G3),MGL**2))*
     &  DCONJG(CF15dsdL(3,I6G3))*MFp+DBLE(B0i(dbb0,MFp2,MGL**
     &  2,MSd2(I6G3)))*(MFp2*DCONJG(CF15dsdL(3,I6G3))*MFp-MGL*
     &  DCONJG(CF15dsdR(3,I6G3))*MFp2)))))/(24d0*Pi**2*MFp)
           enddo

       dZtR1=0D0           !SM-QCD has been removed

           do I6G3 = 1,6
       dZtR1=dZtR1-(g3**2*(CF15usuR(3,I6G3)*(DBLE(B0i(bb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(MGL*DCONJG(CF15usuL(3,I6G3))+2*
     &  DCONJG(CF15usuR(3,I6G3))*MFF)+2*
     &  (DBLE(B0i(bb1,MF2,MSu2(I6G3),MGL**2))*DCONJG(CF15usuR(3,I6G3))*
     &  MFF+MF2*DBLE(B0i(dbb1,MF2,MSu2(I6G3),MGL**2))*
     &  DCONJG(CF15usuR(3,I6G3))*MFF+DBLE(B0i(dbb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(MF2*DCONJG(CF15usuR(3,I6G3))*MFF-MGL*
     &  DCONJG(CF15usuL(3,I6G3))*MF2)))+CF15usuL(3,I6G3)*(-(MGL*
     &  DBLE(B0i(bb0,MF2,MGL**2,MSu2(I6G3)))*DCONJG(CF15usuR(3,I6G3)))+
     &  2*(MF2*DBLE(B0i(dbb1,MF2,MSu2(I6G3),MGL**2))*
     &  DCONJG(CF15usuL(3,I6G3))*MFF+DBLE(B0i(dbb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(MF2*DCONJG(CF15usuL(3,I6G3))*MFF-MGL*
     &  DCONJG(CF15usuR(3,I6G3))*MF2)))))/(24d0*Pi**2*MFF)
           enddo

       dZtL1=0D0                  !SM-QCD has been removed

           do I6G3 = 1,6
       dZtL1=dZtL1+(g3**2*(CF15usuR(3,I6G3)*(MGL*DBLE(B0i(bb0,MF2,MGL**
     &  2,MSu2(I6G3)))*DCONJG(CF15usuL(3,I6G3))-2*(MF2*
     &  DBLE(B0i(dbb1,MF2,MSu2(I6G3),MGL**2))*DCONJG(CF15usuR(3,I6G3))*
     &  MFF+DBLE(B0i(dbb0,MF2,MGL**2,MSu2(I6G3)))*(MF2*
     &  DCONJG(CF15usuR(3,I6G3))*MFF-MGL*DCONJG(CF15usuL(3,I6G3))
     &  *MF2)))-CF15usuL(3,I6G3)*(DBLE(B0i(bb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(MGL*DCONJG(CF15usuR(3,I6G3))+2*
     &  DCONJG(CF15usuL(3,I6G3))*MFF)+2*
     &  (DBLE(B0i(bb1,MF2,MSu2(I6G3),MGL**2))*DCONJG(CF15usuL(3,I6G3))*
     &  MFF+MF2*DBLE(B0i(dbb1,MF2,MSu2(I6G3),MGL**2))*
     &  DCONJG(CF15usuL(3,I6G3))*MFF+DBLE(B0i(dbb0,MF2,MGL**
     &  2,MSu2(I6G3)))*(MF2*DCONJG(CF15usuL(3,I6G3))*MFF-MGL*
     &  DCONJG(CF15usuR(3,I6G3))*MF2)))))/(24d0*Pi**2*MFF)
           enddo
        ! end WFRs for top and bottom



        Do I6G5=1,6
        Do I6G4=1,6
       int5(I6G5,I6G4)=C0i(cc0,MFp2,MCH2,MFF2,MGL2,MSd2(I6G5),MSu2(I6G4))
       int6(I6G5,I6G4)=C0i(cc2,MFp2,MCH2,MFF2,MGL2,MSd2(I6G5),MSu2(I6G4))
       int7(I6G5,I6G4)=C0i(cc1,MFp2,MCH2,MFF2,MGL2,MSd2(I6G5),MSu2(I6G4))
        enddo
        enddo


        part1=0D0           !SM-QCD has been removed
        part2=0D0            !SM-QCD has been removed

        Do I6G4=1,6
        Do I6G5=1,6
       Part1=Part1+(4*g3**2*IC*CHpSumSdm(I6G5,I6G4,2)*(MFF*
     &  int6(I6G5,I6G4)*CF15dsdL(3,I6G5)*DCONJG(CF15usuL(3,I6G4))+MGL*
     &  int5(I6G5,I6G4)*CF15dsdL(3,I6G5)*DCONJG(CF15usuR(3,I6G4))+MFp*
     &  int7(I6G5,I6G4)*CF15dsdR(3,I6G5)*DCONJG(CF15usuR(3,I6G4))))
     &  /3d0

       Part2=Part2+(4*g3**2*IC*CHpSumSdm(I6G5,I6G4,2)*(MFp*
     &  int7(I6G5,I6G4)*CF15dsdL(3,I6G5)*DCONJG(CF15usuL(3,I6G4))+MGL*
     &  int5(I6G5,I6G4)*CF15dsdR(3,I6G5)*DCONJG(CF15usuL(3,I6G4))+MFF*
     &  int6(I6G5,I6G4)*CF15dsdR(3,I6G5)*DCONJG(CF15usuR(3,I6G4))))
     &  /3d0
       enddo
       enddo

		part1=part1*fac
		part2=part2*fac

        CTERMS1 =CtbHpL(3,3,2)*(dmt1/MF)
        CTERMS1 =CTERMS1  + CtbHpL(3,3,2)*(dZbL1/2D0+dZtR1/2D0)
         ! subtract deltab correction to avoid double counting     
        CTERMS2 =CtbHpR(3,3,2)*(dmb1/MFp+(deltambQCD+deltab1+(deltambQCD+deltab1)/tanb**2))
c        CTERMS2 =CtbHpR(3,3,2)*(dmb1/MFP)
        CTERMS2 =CTERMS2  + CtbHpR(3,3,2)*(dZbR1/2D0+dZtL1/2D0)

		part1=part1-CTERMS1
		part2=part2-CTERMS2
        Cloop=-3*2*DBLE(-2D0*MF*MFP*TreeL*DCONJG(part2)
     &   -2D0*MF*MFP*TreeR*DCONJG(part1)+
     &   (MCH2-MF**2-MFP**2)*(TreeL*DCONJG(part1)+TreeR*DCONJG(part2)))


        virtQCD= Cloop*RPhaseSpace2
        awidth=virtQCD
        

#ifdef details
       print*, "==============SUSYQCD H->tb=============="
       print*, "mt,mf",mt,mf
       print*, "mb,mfp,g3",mb,mfp,g3
       print*, "dmt1=",dmt1
       print*, "dmb1,+ deltambQCD+deltab1 subtraction=",dmb1, deltambQCD+deltab1
       print*, "dZbL1,dZbR1=",dZbL1,dZbR1
       print*, "dZtL1,dZtR1=",dZtL1,dZtR1
       print*, "loopleft, loopright", part1	, part2
		print*, "CtbHpl(3,3,2),CtbHpR(3,3,2)",CtbHpl(3,3,2),CtbHpR(3,3,2)	
       print*, "|M|^2_tree=", CTREE
	   print*, " Width_tree=",Treepart
        print*, "2*M_tree*M_loop =", Cloop
	   print*, " Width_1loop_vertex=",virtQCD

       print*, "RPhaseSpace2",RPhaseSpace2
       print*, "vertex,realpart",virtQCD
       print*, "========== END SUSYQCD H->tb=============="
#endif
        endif


       if(ilevel.eq.2 .or. ilevel.gt.3)then


c if:  ischeme=1 for OS scheme; otherwise for DRbar scheme
          if (ischeme.eq.1)then
          p=Mt
       dmt1=(P*(8*e**2*DBLE(B0i(bb1,P**2,0D0,MFu2(3)))+9*(CuuZL**
     &  2+CuuZR**2)*DBLE(B0i(bb1,P**2,MZ2,MFu2(3))))+8*e**2*
     &  DBLE(B0i(bb0,P**2,0D0,MFu2(3)))*(P-2*MassFu(3))+9*
     &  DBLE(B0i(bb0,P**2,MZ2,MFu2(3)))*(CuuZL**2*P+CuuZR**2*P-4*CuuZL*
     &  CuuZR*MassFu(3)))/(144d0*Pi**2)
           do I3G3 = 1,3
       dmt1=dmt1+(P*CbtWm(3,I3G3)*CtbWp(3,I3G3)*(DBLE(B0i(bb0,P**
     &  2,MW2,MFd2(I3G3)))+DBLE(B0i(bb1,P**2,MW2,MFd2(I3G3)))))/(16d0*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dmt1=dmt1+(P*DBLE(B0i(bb1,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  (CtbHpL(3,I3G3,I2G3)*DCONJG(CtbHpL(3,I3G3,I2G3))+
     &  CtbHpR(3,I3G3,I2G3)*DCONJG(CtbHpR(3,I3G3,I2G3)))+
     &  DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  (DCONJG(CtbHpR(3,I3G3,I2G3))*(P*CtbHpR(3,I3G3,I2G3)+
     &  CtbHpL(3,I3G3,I2G3)*MassFd(I3G3))+DCONJG(CtbHpL(3,I3G3,I2G3))*
     &  (P*CtbHpL(3,I3G3,I2G3)+CtbHpR(3,I3G3,I2G3)*MassFd(I3G3))))
     &  /(32d0*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dmt1=dmt1-(2*P*CLhFumFup(3,3,I6G3)*CRhFumFup(3,3,I6G3)*
     &  DBLE(B0i(bb1,P**2,Masshh2(I6G3),MFu2(3)))+DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFu2(3)))*(2*P*CLhFumFup(3,3,I6G3)*
     &  CRhFumFup(3,3,I6G3)+CLhFumFup(3,3,I6G3)**2*MassFu(3)+
     &  CRhFumFup(3,3,I6G3)**2*MassFu(3)))/(32d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dmt1=dmt1+(-(P*DBLE(B0i(bb1,P**2,MCha2(I2G3),MSd2(I6G3)))*
     &  (cupchapsdL(I2G3,3,I6G3)*DCONJG(cupchapsdL(I2G3,3,I6G3))+
     &  cupchapsdR(I2G3,3,I6G3)*DCONJG(cupchapsdR(I2G3,3,I6G3))))+
     &  DBLE(B0i(bb0,P**2,MCha2(I2G3),MSd2(I6G3)))*
     &  (cupchapsdR(I2G3,3,I6G3)*DCONJG(cupchapsdL(I2G3,3,I6G3))+
     &  cupchapsdL(I2G3,3,I6G3)*DCONJG(cupchapsdR(I2G3,3,I6G3)))*
     &  MCha(I2G3))/(32d0*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dmt1=dmt1+(-(P*DBLE(B0i(bb1,P**2,MNeu2(I5G3),MSu2(I6G3)))*
     &  (cchiupsumL(I5G3,3,I6G3)*DCONJG(cchiupsumL(I5G3,3,I6G3))+
     &  cchiupsumR(I5G3,3,I6G3)*DCONJG(cchiupsumR(I5G3,3,I6G3))))+
     &  DBLE(B0i(bb0,P**2,MNeu2(I5G3),MSu2(I6G3)))*
     &  (cchiupsumR(I5G3,3,I6G3)*DCONJG(cchiupsumL(I5G3,3,I6G3))+
     &  cchiupsumL(I5G3,3,I6G3)*DCONJG(cchiupsumR(I5G3,3,I6G3)))*
     &  MNeu(I5G3))/(32d0*Pi**2)
           enddo
           enddo
          else
          dmt1=0
          endif


c if:  ischeme=1 for OS scheme; otherwise for DRbar scheme
          if (ischeme.eq.1)then
          p=Mb
       dmb1=(P*(2*e**2*DBLE(B0i(bb1,P**2,0D0,MFd2(3)))+9*(CddZL**
     &  2+CddZR**2)*DBLE(B0i(bb1,P**2,MZ2,MFd2(3))))+2*e**2*
     &  DBLE(B0i(bb0,P**2,0D0,MFd2(3)))*(P-2*MassFd(3))+9*
     &  DBLE(B0i(bb0,P**2,MZ2,MFd2(3)))*(CddZL**2*P+CddZR**2*P-4*CddZL*
     &  CddZR*MassFd(3)))/(144d0*Pi**2)
           do I3G3 = 1,3
       dmb1=dmb1+(P*CbtWm(I3G3,3)*CtbWp(I3G3,3)*(DBLE(B0i(bb0,P**
     &  2,MW2,MFu2(I3G3)))+DBLE(B0i(bb1,P**2,MW2,MFu2(I3G3)))))/(16d0*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dmb1=dmb1+(P*DBLE(B0i(bb1,P**2,MassHpm2(I2G3),MFu2(I3G3)))*
     &  (CtbHpL(I3G3,3,I2G3)*DCONJG(CtbHpL(I3G3,3,I2G3))+
     &  CtbHpR(I3G3,3,I2G3)*DCONJG(CtbHpR(I3G3,3,I2G3)))+
     &  DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFu2(I3G3)))*
     &  (DCONJG(CtbHpR(I3G3,3,I2G3))*(P*CtbHpR(I3G3,3,I2G3)+
     &  CtbHpL(I3G3,3,I2G3)*MassFu(I3G3))+DCONJG(CtbHpL(I3G3,3,I2G3))*
     &  (P*CtbHpL(I3G3,3,I2G3)+CtbHpR(I3G3,3,I2G3)*MassFu(I3G3))))
     &  /(32d0*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dmb1=dmb1-(2*P*CLhFdpFdm(3,3,I6G3)*CRhFdpFdm(3,3,I6G3)*
     &  DBLE(B0i(bb1,P**2,Masshh2(I6G3),MFd2(3)))+DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFd2(3)))*(2*P*CLhFdpFdm(3,3,I6G3)*
     &  CRhFdpFdm(3,3,I6G3)+CLhFdpFdm(3,3,I6G3)**2*MassFd(3)+
     &  CRhFdpFdm(3,3,I6G3)**2*MassFd(3)))/(32d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dmb1=dmb1+(-(P*DBLE(B0i(bb1,P**2,MCha2(I2G3),MSu2(I6G3)))*
     &  (cdmchapsuL(3,I2G3,I6G3)*DCONJG(cdmchapsuL(3,I2G3,I6G3))+
     &  cdmchapsuR(3,I2G3,I6G3)*DCONJG(cdmchapsuR(3,I2G3,I6G3))))+
     &  DBLE(B0i(bb0,P**2,MCha2(I2G3),MSu2(I6G3)))*
     &  (cdmchapsuR(3,I2G3,I6G3)*DCONJG(cdmchapsuL(3,I2G3,I6G3))+
     &  cdmchapsuL(3,I2G3,I6G3)*DCONJG(cdmchapsuR(3,I2G3,I6G3)))*
     &  MCha(I2G3))/(32d0*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dmb1=dmb1+(-(P*DBLE(B0i(bb1,P**2,MNeu2(I5G3),MSd2(I6G3)))*
     &  (cchidmsdpL(I5G3,3,I6G3)*DCONJG(cchidmsdpL(I5G3,3,I6G3))+
     &  cchidmsdpR(I5G3,3,I6G3)*DCONJG(cchidmsdpR(I5G3,3,I6G3))))+
     &  DBLE(B0i(bb0,P**2,MNeu2(I5G3),MSd2(I6G3)))*
     &  (cchidmsdpR(I5G3,3,I6G3)*DCONJG(cchidmsdpL(I5G3,3,I6G3))+
     &  cchidmsdpL(I5G3,3,I6G3)*DCONJG(cchidmsdpR(I5G3,3,I6G3)))*
     &  MNeu(I5G3))/(32d0*Pi**2)
           enddo
           enddo
        else
       dmb1=0D0
         endif
       ! WFRs for top and bottom are always in OS scheme 
       P=Mt
       dZtR1=-(4*e**2*DBLE(B0i(bb0,P**2,0D0,MFu2(3)))+9*CuuZR**2*
     &  DBLE(B0i(bb0,P**2,MZ2,MFu2(3)))+4*e**2*DBLE(B0i(bb1,P**
     &  2,0D0,MFu2(3)))+9*CuuZR**2*DBLE(B0i(bb1,P**2,MZ2,MFu2(3)))+8*e*
     &  *2*P**2*DBLE(B0i(dbb1,P**2,0D0,MFu2(3)))+9*(CuuZL**2+CuuZR**2)*
     &  P**2*DBLE(B0i(dbb1,P**2,MZ2,MFu2(3)))+8*e**2*P*DBLE(B0i(dbb0,P*
     &  *2,0D0,MFu2(3)))*(P-2*MassFu(3))+9*P*DBLE(B0i(dbb0,P**
     &  2,MZ2,MFu2(3)))*(CuuZL**2*P+CuuZR**2*P-4*CuuZL*CuuZR*MassFu(3))
     &  )/(72d0*Pi**2)
           do I3G3 = 1,3
       dZtR1=dZtR1-(P**2*CbtWm(3,I3G3)*CtbWp(3,I3G3)*(DBLE(B0i(dbb0,P*
     &  *2,MW2,MFd2(I3G3)))+DBLE(B0i(dbb1,P**2,MW2,MFd2(I3G3)))))/(8d0*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZtR1=dZtR1+(CtbHpR(3,I3G3,I2G3)*(-2*P**3*DBLE(B0i(dbb1,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*DCONJG(CtbHpR(3,I3G3,I2G3))+
     &  DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  DCONJG(CtbHpL(3,I3G3,I2G3))*MassFd(I3G3)-2*P**2*
     &  DBLE(B0i(dbb0,P**2,MassHpm2(I2G3),MFd2(I3G3)))*(P*
     &  DCONJG(CtbHpR(3,I3G3,I2G3))+DCONJG(CtbHpL(3,I3G3,I2G3))*
     &  MassFd(I3G3)))-CtbHpL(3,I3G3,I2G3)*(DBLE(B0i(bb0,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*(2*P*DCONJG(CtbHpL(3,I3G3,I2G3))+
     &  DCONJG(CtbHpR(3,I3G3,I2G3))*MassFd(I3G3))+2*P*(DBLE(B0i(bb1,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*DCONJG(CtbHpL(3,I3G3,I2G3))+P*(P*
     &  DBLE(B0i(dbb1,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  DCONJG(CtbHpL(3,I3G3,I2G3))+DBLE(B0i(dbb0,P**2,MassHpm2(I2G3)
     &  ,MFd2(I3G3)))*(P*DCONJG(CtbHpL(3,I3G3,I2G3))+
     &  DCONJG(CtbHpR(3,I3G3,I2G3))*MassFd(I3G3))))))/(32d0*P*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZtR1=dZtR1+(2*P*CLhFumFup(3,3,I6G3)*CRhFumFup(3,3,I6G3)*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFu2(3)))+DBLE(B0i(bb1,P**
     &  2,Masshh2(I6G3),MFu2(3)))+2*P**2*(DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFu2(3)))+DBLE(B0i(dbb1,P**2,Masshh2(I6G3)
     &  ,MFu2(3)))))-CRhFumFup(3,3,I6G3)**2*(DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFu2(3)))-2*P**2*DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFu2(3))))*MassFu(3)+CLhFumFup(3,3,I6G3)**2*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFu2(3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,Masshh2(I6G3),MFu2(3))))*MassFu(3))/(32d0*P*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dZtR1=dZtR1+(cupchapsdR(I2G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**
     &  2,MCha2(I2G3),MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,3,I6G3))+2*P*
     &  *3*DBLE(B0i(dbb1,P**2,MCha2(I2G3),MSd2(I6G3)))*
     &  DCONJG(cupchapsdR(I2G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MCha2(I2G3)
     &  ,MSd2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSd2(I6G3))
     &  ))*DCONJG(cupchapsdL(I2G3,3,I6G3))*MCha(I2G3))+
     &  cupchapsdL(I2G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,3,I6G3))-(DBLE(B0i(bb0,P**
     &  2,MCha2(I2G3),MSd2(I6G3)))+2*P**2*DBLE(B0i(dbb0,P**
     &  2,MCha2(I2G3),MSd2(I6G3))))*DCONJG(cupchapsdR(I2G3,3,I6G3))*
     &  MCha(I2G3)))/(32d0*P*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZtR1=dZtR1+(cchiupsumR(I5G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**
     &  2,MNeu2(I5G3),MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,3,I6G3))+2*P*
     &  *3*DBLE(B0i(dbb1,P**2,MNeu2(I5G3),MSu2(I6G3)))*
     &  DCONJG(cchiupsumR(I5G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSu2(I6G3))
     &  ))*DCONJG(cchiupsumL(I5G3,3,I6G3))*MNeu(I5G3))+
     &  cchiupsumL(I5G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,3,I6G3))-(DBLE(B0i(bb0,P**
     &  2,MNeu2(I5G3),MSu2(I6G3)))+2*P**2*DBLE(B0i(dbb0,P**
     &  2,MNeu2(I5G3),MSu2(I6G3))))*DCONJG(cchiupsumR(I5G3,3,I6G3))*
     &  MNeu(I5G3)))/(32d0*P*Pi**2)
           enddo
           enddo

       dZtL1=-(4*e**2*DBLE(B0i(bb0,P**2,0D0,MFu2(3)))+9*CuuZL**2*
     &  DBLE(B0i(bb0,P**2,MZ2,MFu2(3)))+4*e**2*DBLE(B0i(bb1,P**
     &  2,0D0,MFu2(3)))+9*CuuZL**2*DBLE(B0i(bb1,P**2,MZ2,MFu2(3)))+8*e*
     &  *2*P**2*DBLE(B0i(dbb1,P**2,0D0,MFu2(3)))+9*(CuuZL**2+CuuZR**2)*
     &  P**2*DBLE(B0i(dbb1,P**2,MZ2,MFu2(3)))+8*e**2*P*DBLE(B0i(dbb0,P*
     &  *2,0D0,MFu2(3)))*(P-2*MassFu(3))+9*P*DBLE(B0i(dbb0,P**
     &  2,MZ2,MFu2(3)))*(CuuZL**2*P+CuuZR**2*P-4*CuuZL*CuuZR*MassFu(3))
     &  )/(72d0*Pi**2)
           do I3G3 = 1,3
       dZtL1=dZtL1-(CbtWm(3,I3G3)*CtbWp(3,I3G3)*(DBLE(B0i(bb0,P**
     &  2,MW2,MFd2(I3G3)))+DBLE(B0i(bb1,P**2,MW2,MFd2(I3G3)))+P**2*
     &  (DBLE(B0i(dbb0,P**2,MW2,MFd2(I3G3)))+DBLE(B0i(dbb1,P**
     &  2,MW2,MFd2(I3G3))))))/(8d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZtL1=dZtL1+(CtbHpL(3,I3G3,I2G3)*(-2*P**3*DBLE(B0i(dbb1,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*DCONJG(CtbHpL(3,I3G3,I2G3))+
     &  DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  DCONJG(CtbHpR(3,I3G3,I2G3))*MassFd(I3G3)-2*P**2*
     &  DBLE(B0i(dbb0,P**2,MassHpm2(I2G3),MFd2(I3G3)))*(P*
     &  DCONJG(CtbHpL(3,I3G3,I2G3))+DCONJG(CtbHpR(3,I3G3,I2G3))*
     &  MassFd(I3G3)))-CtbHpR(3,I3G3,I2G3)*(DBLE(B0i(bb0,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*(2*P*DCONJG(CtbHpR(3,I3G3,I2G3))+
     &  DCONJG(CtbHpL(3,I3G3,I2G3))*MassFd(I3G3))+2*P*(DBLE(B0i(bb1,P**
     &  2,MassHpm2(I2G3),MFd2(I3G3)))*DCONJG(CtbHpR(3,I3G3,I2G3))+P*(P*
     &  DBLE(B0i(dbb1,P**2,MassHpm2(I2G3),MFd2(I3G3)))*
     &  DCONJG(CtbHpR(3,I3G3,I2G3))+DBLE(B0i(dbb0,P**2,MassHpm2(I2G3)
     &  ,MFd2(I3G3)))*(P*DCONJG(CtbHpR(3,I3G3,I2G3))+
     &  DCONJG(CtbHpL(3,I3G3,I2G3))*MassFd(I3G3))))))/(32d0*P*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZtL1=dZtL1+(2*P*CLhFumFup(3,3,I6G3)*CRhFumFup(3,3,I6G3)*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFu2(3)))+DBLE(B0i(bb1,P**
     &  2,Masshh2(I6G3),MFu2(3)))+2*P**2*(DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFu2(3)))+DBLE(B0i(dbb1,P**2,Masshh2(I6G3)
     &  ,MFu2(3)))))-CLhFumFup(3,3,I6G3)**2*(DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFu2(3)))-2*P**2*DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFu2(3))))*MassFu(3)+CRhFumFup(3,3,I6G3)**2*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFu2(3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,Masshh2(I6G3),MFu2(3))))*MassFu(3))/(32d0*P*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dZtL1=dZtL1+(cupchapsdR(I2G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**
     &  2,MCha2(I2G3),MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,3,I6G3))-
     &  (DBLE(B0i(bb0,P**2,MCha2(I2G3),MSd2(I6G3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSd2(I6G3))))*
     &  DCONJG(cupchapsdL(I2G3,3,I6G3))*MCha(I2G3))+
     &  cupchapsdL(I2G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,3,I6G3))+2*P**3*
     &  DBLE(B0i(dbb1,P**2,MCha2(I2G3),MSd2(I6G3)))*
     &  DCONJG(cupchapsdL(I2G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MCha2(I2G3)
     &  ,MSd2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSd2(I6G3))
     &  ))*DCONJG(cupchapsdR(I2G3,3,I6G3))*MCha(I2G3)))/(32d0*P*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZtL1=dZtL1+(cchiupsumR(I5G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**
     &  2,MNeu2(I5G3),MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,3,I6G3))-
     &  (DBLE(B0i(bb0,P**2,MNeu2(I5G3),MSu2(I6G3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSu2(I6G3))))*
     &  DCONJG(cchiupsumL(I5G3,3,I6G3))*MNeu(I5G3))+
     &  cchiupsumL(I5G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,3,I6G3))+2*P**3*
     &  DBLE(B0i(dbb1,P**2,MNeu2(I5G3),MSu2(I6G3)))*
     &  DCONJG(cchiupsumL(I5G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSu2(I6G3))
     &  ))*DCONJG(cchiupsumR(I5G3,3,I6G3))*MNeu(I5G3)))/(32d0*P*Pi**2)
           enddo
           enddo

       P=Mb
       dZbR1=-(e**2*(DBLE(B0i(bb0,P**2,0D0,MFd2(3)))+
     &  DBLE(B0i(bb1,P**2,0D0,MFd2(3))))+9*CddZR**2*(DBLE(B0i(bb0,P**
     &  2,MZ2,MFd2(3)))+DBLE(B0i(bb1,P**2,MZ2,MFd2(3))))+2*e**2*P**2*
     &  DBLE(B0i(dbb1,P**2,0D0,MFd2(3)))+9*(CddZL**2+CddZR**2)*P**2*
     &  DBLE(B0i(dbb1,P**2,MZ2,MFd2(3)))+2*e**2*P*DBLE(B0i(dbb0,P**
     &  2,0D0,MFd2(3)))*(P-2*MassFd(3))+9*P*DBLE(B0i(dbb0,P**
     &  2,MZ2,MFd2(3)))*(CddZL**2*P+CddZR**2*P-4*CddZL*CddZR*MassFd(3))
     &  )/(72d0*Pi**2)
           do I3G3 = 1,3
       dZbR1=dZbR1-(P**2*CbtWm(I3G3,3)*CtbWp(I3G3,3)*(DBLE(B0i(dbb0,P*
     &  *2,MW2,MFu2(I3G3)))+DBLE(B0i(dbb1,P**2,MW2,MFu2(I3G3)))))/(8d0*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZbR1=dZbR1-(2*CtbHpR(I3G3,3,I2G3)*DBLE(B0i(bb1,P**
     &  2,MassHpm2(I2G3),MFu2(I3G3)))*DCONJG(CtbHpR(I3G3,3,I2G3))+2*P**
     &  2*DBLE(B0i(dbb1,P**2,MassHpm2(I2G3),MFu2(I3G3)))*
     &  (CtbHpL(I3G3,3,I2G3)*DCONJG(CtbHpL(I3G3,3,I2G3))+
     &  CtbHpR(I3G3,3,I2G3)*DCONJG(CtbHpR(I3G3,3,I2G3)))+
     &  (DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFu2(I3G3)))*(-
     &  (CtbHpR(I3G3,3,I2G3)*DCONJG(CtbHpL(I3G3,3,I2G3))*MassFu(I3G3))+
     &  DCONJG(CtbHpR(I3G3,3,I2G3))*(2*P*CtbHpR(I3G3,3,I2G3)+
     &  CtbHpL(I3G3,3,I2G3)*MassFu(I3G3))))/P+2*P*DBLE(B0i(dbb0,P**
     &  2,MassHpm2(I2G3),MFu2(I3G3)))*(DCONJG(CtbHpR(I3G3,3,I2G3))*(P*
     &  CtbHpR(I3G3,3,I2G3)+CtbHpL(I3G3,3,I2G3)*MassFu(I3G3))+
     &  DCONJG(CtbHpL(I3G3,3,I2G3))*(P*CtbHpL(I3G3,3,I2G3)+
     &  CtbHpR(I3G3,3,I2G3)*MassFu(I3G3))))/(32d0*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZbR1=dZbR1+(2*P*CLhFdpFdm(3,3,I6G3)*CRhFdpFdm(3,3,I6G3)*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFd2(3)))+DBLE(B0i(bb1,P**
     &  2,Masshh2(I6G3),MFd2(3)))+2*P**2*(DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFd2(3)))+DBLE(B0i(dbb1,P**2,Masshh2(I6G3)
     &  ,MFd2(3)))))-CRhFdpFdm(3,3,I6G3)**2*(DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFd2(3)))-2*P**2*DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFd2(3))))*MassFd(3)+CLhFdpFdm(3,3,I6G3)**2*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFd2(3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,Masshh2(I6G3),MFd2(3))))*MassFd(3))/(32d0*P*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dZbR1=dZbR1+(cdmchapsuR(3,I2G3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**
     &  2,MCha2(I2G3),MSu2(I6G3)))*DCONJG(cdmchapsuR(3,I2G3,I6G3))+
     &  (DBLE(B0i(bb0,P**2,MCha2(I2G3),MSu2(I6G3)))-2*P**2*
     &  DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSu2(I6G3))))*
     &  DCONJG(cdmchapsuL(3,I2G3,I6G3))*MCha(I2G3))+
     &  cdmchapsuL(3,I2G3,I6G3)*(2*P*DBLE(B0i(bb1,P**2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(3,I2G3,I6G3))+2*P**3*
     &  DBLE(B0i(dbb1,P**2,MCha2(I2G3),MSu2(I6G3)))*
     &  DCONJG(cdmchapsuL(3,I2G3,I6G3))-(DBLE(B0i(bb0,P**2,MCha2(I2G3)
     &  ,MSu2(I6G3)))+2*P**2*DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSu2(I6G3))
     &  ))*DCONJG(cdmchapsuR(3,I2G3,I6G3))*MCha(I2G3)))/(32d0*P*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZbR1=dZbR1+(cchidmsdpR(I5G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**
     &  2,MNeu2(I5G3),MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,3,I6G3))+2*P*
     &  *3*DBLE(B0i(dbb1,P**2,MNeu2(I5G3),MSd2(I6G3)))*
     &  DCONJG(cchidmsdpR(I5G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSd2(I6G3))
     &  ))*DCONJG(cchidmsdpL(I5G3,3,I6G3))*MNeu(I5G3))+
     &  cchidmsdpL(I5G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,3,I6G3))-(DBLE(B0i(bb0,P**
     &  2,MNeu2(I5G3),MSd2(I6G3)))+2*P**2*DBLE(B0i(dbb0,P**
     &  2,MNeu2(I5G3),MSd2(I6G3))))*DCONJG(cchidmsdpR(I5G3,3,I6G3))*
     &  MNeu(I5G3)))/(32d0*P*Pi**2)
           enddo
           enddo

       dZbL1=-(e**2*(DBLE(B0i(bb0,P**2,0D0,MFd2(3)))+
     &  DBLE(B0i(bb1,P**2,0D0,MFd2(3))))+9*CddZL**2*(DBLE(B0i(bb0,P**
     &  2,MZ2,MFd2(3)))+DBLE(B0i(bb1,P**2,MZ2,MFd2(3))))+2*e**2*P**2*
     &  DBLE(B0i(dbb1,P**2,0D0,MFd2(3)))+9*(CddZL**2+CddZR**2)*P**2*
     &  DBLE(B0i(dbb1,P**2,MZ2,MFd2(3)))+2*e**2*P*DBLE(B0i(dbb0,P**
     &  2,0D0,MFd2(3)))*(P-2*MassFd(3))+9*P*DBLE(B0i(dbb0,P**
     &  2,MZ2,MFd2(3)))*(CddZL**2*P+CddZR**2*P-4*CddZL*CddZR*MassFd(3))
     &  )/(72d0*Pi**2)
           do I3G3 = 1,3
       dZbL1=dZbL1-(CbtWm(I3G3,3)*CtbWp(I3G3,3)*(DBLE(B0i(bb0,P**
     &  2,MW2,MFu2(I3G3)))+DBLE(B0i(bb1,P**2,MW2,MFu2(I3G3)))+P**2*
     &  (DBLE(B0i(dbb0,P**2,MW2,MFu2(I3G3)))+DBLE(B0i(dbb1,P**
     &  2,MW2,MFu2(I3G3))))))/(8d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZbL1=dZbL1-(2*CtbHpL(I3G3,3,I2G3)*DBLE(B0i(bb1,P**
     &  2,MassHpm2(I2G3),MFu2(I3G3)))*DCONJG(CtbHpL(I3G3,3,I2G3))+2*P**
     &  2*DBLE(B0i(dbb1,P**2,MassHpm2(I2G3),MFu2(I3G3)))*
     &  (CtbHpL(I3G3,3,I2G3)*DCONJG(CtbHpL(I3G3,3,I2G3))+
     &  CtbHpR(I3G3,3,I2G3)*DCONJG(CtbHpR(I3G3,3,I2G3)))+2*P*
     &  DBLE(B0i(dbb0,P**2,MassHpm2(I2G3),MFu2(I3G3)))*
     &  (DCONJG(CtbHpR(I3G3,3,I2G3))*(P*CtbHpR(I3G3,3,I2G3)+
     &  CtbHpL(I3G3,3,I2G3)*MassFu(I3G3))+DCONJG(CtbHpL(I3G3,3,I2G3))*
     &  (P*CtbHpL(I3G3,3,I2G3)+CtbHpR(I3G3,3,I2G3)*MassFu(I3G3)))+
     &  (DBLE(B0i(bb0,P**2,MassHpm2(I2G3),MFu2(I3G3)))*(-
     &  (CtbHpL(I3G3,3,I2G3)*DCONJG(CtbHpR(I3G3,3,I2G3))*MassFu(I3G3))+
     &  DCONJG(CtbHpL(I3G3,3,I2G3))*(2*P*CtbHpL(I3G3,3,I2G3)+
     &  CtbHpR(I3G3,3,I2G3)*MassFu(I3G3))))/P)/(32d0*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZbL1=dZbL1+(2*P*CLhFdpFdm(3,3,I6G3)*CRhFdpFdm(3,3,I6G3)*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFd2(3)))+DBLE(B0i(bb1,P**
     &  2,Masshh2(I6G3),MFd2(3)))+2*P**2*(DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFd2(3)))+DBLE(B0i(dbb1,P**2,Masshh2(I6G3)
     &  ,MFd2(3)))))-CLhFdpFdm(3,3,I6G3)**2*(DBLE(B0i(bb0,P**
     &  2,Masshh2(I6G3),MFd2(3)))-2*P**2*DBLE(B0i(dbb0,P**
     &  2,Masshh2(I6G3),MFd2(3))))*MassFd(3)+CRhFdpFdm(3,3,I6G3)**2*
     &  (DBLE(B0i(bb0,P**2,Masshh2(I6G3),MFd2(3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,Masshh2(I6G3),MFd2(3))))*MassFd(3))/(32d0*P*
     &  Pi**2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dZbL1=dZbL1+(cdmchapsuR(3,I2G3,I6G3)*(2*P*DBLE(B0i(bb1,P**
     &  2,MCha2(I2G3),MSu2(I6G3)))*DCONJG(cdmchapsuR(3,I2G3,I6G3))+2*P*
     &  *3*DBLE(B0i(dbb1,P**2,MCha2(I2G3),MSu2(I6G3)))*
     &  DCONJG(cdmchapsuR(3,I2G3,I6G3))-(DBLE(B0i(bb0,P**2,MCha2(I2G3)
     &  ,MSu2(I6G3)))+2*P**2*DBLE(B0i(dbb0,P**2,MCha2(I2G3),MSu2(I6G3))
     &  ))*DCONJG(cdmchapsuL(3,I2G3,I6G3))*MCha(I2G3))+
     &  cdmchapsuL(3,I2G3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(3,I2G3,I6G3))+(DBLE(B0i(bb0,P**
     &  2,MCha2(I2G3),MSu2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**
     &  2,MCha2(I2G3),MSu2(I6G3))))*DCONJG(cdmchapsuR(3,I2G3,I6G3))*
     &  MCha(I2G3)))/(32d0*P*Pi**2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZbL1=dZbL1+(cchidmsdpR(I5G3,3,I6G3)*(2*P**3*DBLE(B0i(dbb1,P**
     &  2,MNeu2(I5G3),MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,3,I6G3))-
     &  (DBLE(B0i(bb0,P**2,MNeu2(I5G3),MSd2(I6G3)))+2*P**2*
     &  DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSd2(I6G3))))*
     &  DCONJG(cchidmsdpL(I5G3,3,I6G3))*MNeu(I5G3))+
     &  cchidmsdpL(I5G3,3,I6G3)*(2*P*DBLE(B0i(bb1,P**2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,3,I6G3))+2*P**3*
     &  DBLE(B0i(dbb1,P**2,MNeu2(I5G3),MSd2(I6G3)))*
     &  DCONJG(cchidmsdpL(I5G3,3,I6G3))+(DBLE(B0i(bb0,P**2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))-2*P**2*DBLE(B0i(dbb0,P**2,MNeu2(I5G3),MSd2(I6G3))
     &  ))*DCONJG(cchidmsdpR(I5G3,3,I6G3))*MNeu(I5G3)))/(32d0*P*Pi**2)
           enddo
           enddo
        ! end WFRs for top and bottom

        dZCHiggs(2,2)=     dZCH()
        dZCHW=SelfHpWm()


       aint1=B0i(bb0,MFp2,MZ2,MFd2(3))
       aint2=B0i(bb0,MFp2,MassHpm2(2),MFu2(3))
       aint3=B0i(bb0,MFp2,0D0,MFd2(3))
       aint5=B0i(bb0,MFp2,MW2,MFu2(3))
       aint8=C0i(cc2,MCH2,MFF2,MFp2,MZ2,MassHpm2(2),MFd2(3))
       aint9=C0i(cc1,MCH2,MFF2,MFp2,0D0,MW2,MFd2(3))
       aint10=C0i(cc1,MCH2,MFp2,MFF2,0D0,MW2,MFu2(3))
       aint11=C0i(cc2,MCH2,MFF2,MFp2,0D0,MW2,MFd2(3))
       aint12=C0i(cc0,MCH2,MFF2,MFp2,0D0,MW2,MFd2(3))
       aint13=C0i(cc2,MCH2,MFp2,MFF2,0D0,MW2,MFu2(3))
       aint14=C0i(cc0,MCH2,MFp2,MFF2,0D0,MW2,MFu2(3))
       aint15=C0i(cc1,MCH2,MFF2,MFp2,MW2,MZ2,MFu2(3))
       aint16=C0i(cc1,MCH2,MFp2,MFF2,MW2,MZ2,MFd2(3))
       aint17=C0i(cc2,MCH2,MFF2,MFp2,MW2,MZ2,MFu2(3))
       aint18=C0i(cc2,MCH2,MFp2,MFF2,MW2,MZ2,MFd2(3))
       aint19=C0i(cc0,MCH2,MFp2,MFF2,MW2,MZ2,MFd2(3))
       aint20=C0i(cc0,MCH2,MFF2,MFp2,MW2,MZ2,MFu2(3))
       aint21=C0i(cc1,MCH2,MFF2,MFp2,MZ2,MassHpm2(2),MFd2(3))
       aint22=C0i(cc2,MCH2,MFp2,MFF2,MZ2,MassHpm2(2),MFu2(3))
       aint23=C0i(cc0,MCH2,MFp2,MFF2,MZ2,MassHpm2(2),MFu2(3))
       aint24=C0i(cc1,MCH2,MFp2,MFF2,MZ2,MassHpm2(2),MFu2(3))
       aint25=C0i(cc0,MCH2,MFF2,MFp2,MZ2,MassHpm2(2),MFd2(3))
       aint26=C0i(cc1,MCH2,MFF2,MFp2,0D0,MassHpm2(2),MFd2(3))
       aint27=C0i(cc0,MCH2,MFF2,MFp2,0D0,MassHpm2(2),MFd2(3))
       aint28=C0i(cc2,MFp2,MCH2,MFF2,MZ2,MFd2(3),MFu2(3))
       aint29=C0i(cc1,MFp2,MCH2,MFF2,MZ2,MFd2(3),MFu2(3))
       aint30=C0i(cc0,MFp2,MCH2,MFF2,MZ2,MFd2(3),MFu2(3))
       aint31=C0i(cc2,MCH2,MFF2,MFp2,0D0,MassHpm2(2),MFd2(3))
       aint32=C0i(cc0,MCH2,MFp2,MFF2,0D0,MassHpm2(2),MFu2(3))
       aint33=C0i(cc2,MCH2,MFp2,MFF2,0D0,MassHpm2(2),MFu2(3))
       aint34=C0i(cc1,MCH2,MFp2,MFF2,0D0,MassHpm2(2),MFu2(3))
       aint35=C0i(cc2,MFp2,MCH2,MFF2,0D0,MFd2(3),MFu2(3))
       aint36=C0i(cc1,MFp2,MCH2,MFF2,0D0,MFd2(3),MFu2(3))
       aint37=C0i(cc0,MFp2,MCH2,MFF2,0D0,MFd2(3),MFu2(3))
        Do I6G4=1,6
       aint4(I6G4)=B0i(bb0,MFp2,Masshh2(I6G4),MFd2(3))
       aint38(I6G4)=C0i(cc2,MCH2,MFp2,MFF2,MW2,Masshh2(I6G4),MFd2(3))
       aint39(I6G4)=C0i(cc1,MCH2,MFp2,MFF2,MW2,Masshh2(I6G4),MFd2(3))
       aint40(I6G4)=C0i(cc2,MCH2,MFF2,MFp2,MW2,Masshh2(I6G4),MFu2(3))
       aint41(I6G4)=C0i(cc1,MCH2,MFF2,MFp2,MW2,Masshh2(I6G4),MFu2(3))
       aint42(I6G4)=C0i(cc2,MFp2,MCH2,MFF2,Masshh2(I6G4),MFd2(3),MFu2(3))
       aint43(I6G4)=C0i(cc1,MFp2,MCH2,MFF2,Masshh2(I6G4),MFd2(3),MFu2(3))
       aint44(I6G4)=C0i(cc0,MCH2,MFp2,MFF2,MW2,Masshh2(I6G4),MFd2(3))
       aint45(I6G4)=C0i(cc0,MCH2,MFF2,MFp2,MW2,Masshh2(I6G4),MFu2(3))
       aint46(I6G4)=C0i(cc0,MFp2,MCH2,MFF2,Masshh2(I6G4),MFd2(3),MFu2(3))
        enddo
        Do I2G4=1,2
        Do I6G4=1,6
       aint6(I2G4,I6G4)=B0i(bb0,MFp2,MCha2(I2G4),MSu2(I6G4))
       aint47(I6G4,I2G4)=C0i(cc1,MCH2,MFF2,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFd2(3))
       aint48(I6G4,I2G4)=C0i(cc2,MCH2,MFF2,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFd2(3))
       aint49(I6G4,I2G4)=C0i(cc2,MCH2,MFp2,MFF2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFu2(3))
       aint50(I6G4,I2G4)=C0i(cc1,MCH2,MFp2,MFF2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFu2(3))
       aint51(I6G4,I2G4)=C0i(cc0,MCH2,MFF2,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFd2(3))
       aint52(I6G4,I2G4)=C0i(cc0,MCH2,MFp2,MFF2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFu2(3))
        enddo
        enddo
        Do I5G4=1,5
        Do I6G4=1,6
       aint7(I5G4,I6G4)=B0i(bb0,MFp2,MNeu2(I5G4),MSd2(I6G4))
        enddo
        enddo
        Do I2G4=1,2
        Do I5G4=1,5
        Do I6G4=1,6
       aint53(I2G4,I5G4,I6G4)=C0i(cc2,MCH2,MFF2,MFp2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSu2(I6G4))
       aint54(I2G4,I5G4,I6G4)=C0i(cc1,MCH2,MFp2,MFF2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSd2(I6G4))
       aint55(I2G4,I5G4,I6G4)=C0i(cc0,MCH2,MFp2,MFF2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSd2(I6G4))
       aint56(I2G4,I5G4,I6G4)=C0i(cc1,MCH2,MFF2,MFp2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSu2(I6G4))
       aint57(I2G4,I5G4,I6G4)=C0i(cc2,MCH2,MFp2,MFF2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSd2(I6G4))
       aint58(I2G4,I5G4,I6G4)=C0i(cc0,MCH2,MFF2,MFp2,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSu2(I6G4))
        enddo
        enddo
        enddo
        Do I5G4=1,5
        Do I6G5=1,6
        Do I6G4=1,6
       aint59(I5G4,I6G5,I6G4)=C0i(cc2,MFp2,MCH2,MFF2,MNeu2(I5G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
       aint60(I5G4,I6G5,I6G4)=C0i(cc1,MFp2,MCH2,MFF2,MNeu2(I5G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
       aint61(I5G4,I6G5,I6G4)=C0i(cc0,MFp2,MCH2,MFF2,MNeu2(I5G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
        enddo
        enddo
        enddo

        
        part1=0;part2=0
    
        Do I5G4=1,5
        Do I6G4=1,6
        Do I6G5=1,6
       Part1=Part1+3*IC*CHpSumSdm(I6G5,I6G4,2)*(MFF*
     &  aint59(I5G4,I6G5,I6G4)*cchidmsdpL(I5G4,3,I6G5)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))+MFp*aint60(I5G4,I6G5,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G5)*DCONJG(cchiupsumR(I5G4,3,I6G4))-
     &  aint61(I5G4,I6G5,I6G4)*cchidmsdpL(I5G4,3,I6G5)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*MNeu(I5G4))
       Part2=Part2+3*IC*CHpSumSdm(I6G5,I6G4,2)*(MFp*
     &  aint60(I5G4,I6G5,I6G4)*cchidmsdpL(I5G4,3,I6G5)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))+MFF*aint59(I5G4,I6G5,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G5)*DCONJG(cchiupsumR(I5G4,3,I6G4))-
     &  aint61(I5G4,I6G5,I6G4)*cchidmsdpR(I5G4,3,I6G5)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*MNeu(I5G4))
       enddo
       enddo
       enddo
       
        Do I2G4=1,2
        Do I5G4=1,5
        Do I6G4=1,6
       Part1=Part1+3*IC*(MFF*MFp*aint53(I2G4,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))+MCH2*aint53(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))-MFF2*aint53(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))+MCH2*aint56(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))+MCH2*aint58(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))-aint6(I2G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))+MFF*MFp*aint57(I2G4,I5G4,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdL(I2G4,3,I6G4))-MCH2*aint54(I2G4,I5G4,I6G4)*
     &  cchidmsdpL(I5G4,3,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdR(I2G4,3,I6G4))-MFF2*aint57(I2G4,I5G4,I6G4)*
     &  cchidmsdpL(I5G4,3,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdR(I2G4,3,I6G4))-aint7(I5G4,I6G4)*
     &  cchidmsdpL(I5G4,3,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdR(I2G4,3,I6G4))+MFp*aint53(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))*MCha(I2G4)+MFp*
     &  aint56(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MCha(I2G4)+MFp*aint58(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MCha(I2G4)-MFF*aint56(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)-MFF*aint58(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)+MFF*aint54(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha(I2G4)+MFF*aint55(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha(I2G4)+MFF*aint57(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha(I2G4)-MFp*aint54(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha(I2G4)-MFp*aint55(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha(I2G4)-aint55(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha2(I2G4)+MFp*aint53(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MNeu(I5G4)+MFp*aint56(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MNeu(I5G4)-MFF*aint56(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MNeu(I5G4)+MFF*aint54(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MNeu(I5G4)+MFF*aint57(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MNeu(I5G4)-MFp*aint54(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MNeu(I5G4)-aint58(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)*MNeu(I5G4)-aint55(I2G4,I5G4,I6G4)*
     &  cchidmsdpL(I5G4,3,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdR(I2G4,3,I6G4))*MCha(I2G4)*MNeu(I5G4)-
     &  aint58(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))*MNeu2(I5G4))
       Part2=Part2+3*IC*(MCH2*aint53(I2G4,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))-MFF2*aint53(I2G4,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))+MCH2*aint56(I2G4,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))+MCH2*aint58(I2G4,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))-aint6(I2G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumL(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))+MFF*MFp*aint53(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuR(3,I2G4,I6G4))-MCH2*aint54(I2G4,I5G4,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdL(I2G4,3,I6G4))-MFF2*aint57(I2G4,I5G4,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdL(I2G4,3,I6G4))-aint7(I5G4,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdL(I2G4,3,I6G4))+MFF*MFp*aint57(I2G4,I5G4,I6G4)*
     &  cchidmsdpL(I5G4,3,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdR(I2G4,3,I6G4))-MFF*aint56(I2G4,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cchiupsumR(I5G4,3,I6G4))*
     &  DCONJG(cdmchapsuL(3,I2G4,I6G4))*MCha(I2G4)-MFF*
     &  aint58(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MCha(I2G4)+MFp*aint53(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)+MFp*aint56(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)+MFp*aint58(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MCha(I2G4)-MFp*aint54(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha(I2G4)-MFp*aint55(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha(I2G4)+MFF*aint54(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha(I2G4)+MFF*aint55(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha(I2G4)+MFF*aint57(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MCha(I2G4)-aint55(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MCha2(I2G4)-MFF*aint56(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumR(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MNeu(I5G4)+MFp*aint53(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MNeu(I5G4)+MFp*aint56(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuR(3,I2G4,I6G4))
     &  *MNeu(I5G4)-MFp*aint54(I2G4,I5G4,I6G4)*cchidmsdpL(I5G4,3,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdL(I2G4,3,I6G4))*
     &  MNeu(I5G4)+MFF*aint54(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MNeu(I5G4)+MFF*aint57(I2G4,I5G4,I6G4)*cchidmsdpR(I5G4,3,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(cupchapsdR(I2G4,3,I6G4))*
     &  MNeu(I5G4)-aint58(I2G4,I5G4,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))
     &  *MCha(I2G4)*MNeu(I5G4)-aint55(I2G4,I5G4,I6G4)*
     &  cchidmsdpR(I5G4,3,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cupchapsdL(I2G4,3,I6G4))*MCha(I2G4)*MNeu(I5G4)-
     &  aint58(I2G4,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(cchiupsumL(I5G4,3,I6G4))*DCONJG(cdmchapsuL(3,I2G4,I6G4))*MNeu2(I5G4))
       enddo
       enddo
       enddo
       

        Part1=Part1+(-9*aint1*CddZL*CHpHmZ*CtbHpL(3,3,2)-36*aint1*CddZL*
     &  CuuZR*CtbHpL(3,3,2)+9*aint2*CHpHmZ*CuuZR*CtbHpL(3,3,2)-6*aint2*
     &  e**2*CtbHpL(3,3,2)+5*aint3*e**2*CtbHpL(3,3,2)-9*aint21*CddZL*
     &  CHpHmZ*MCH2*CtbHpL(3,3,2)-9*aint25*CddZL*CHpHmZ*MCH2*
     &  CtbHpL(3,3,2)-9*aint8*CddZL*CHpHmZ*MCH2*CtbHpL(3,3,2)+18*
     &  aint28*CddZL*CuuZR*MCH2*CtbHpL(3,3,2)-18*aint29*CddZL*CuuZR*
     &  MCH2*CtbHpL(3,3,2)+18*aint30*CddZL*CuuZR*MCH2*CtbHpL(3,3,2)+18*
     &  aint22*CHpHmZ*CuuZR*MCH2*CtbHpL(3,3,2)+18*aint23*CHpHmZ*CuuZR*
     &  MCH2*CtbHpL(3,3,2)+27*aint24*CHpHmZ*CuuZR*MCH2*CtbHpL(3,3,2)-3*
     &  aint26*e**2*MCH2*CtbHpL(3,3,2)-3*aint27*e**2*MCH2*CtbHpL(3,3,2)
     &  -3*aint31*e**2*MCH2*CtbHpL(3,3,2)-12*aint32*e**2*MCH2*
     &  CtbHpL(3,3,2)-12*aint33*e**2*MCH2*CtbHpL(3,3,2)-18*aint34*e**2*
     &  MCH2*CtbHpL(3,3,2)-4*aint35*e**2*MCH2*CtbHpL(3,3,2)+4*aint36*e*
     &  *2*MCH2*CtbHpL(3,3,2)-4*aint37*e**2*MCH2*CtbHpL(3,3,2)+9*
     &  aint21*CddZL*CHpHmZ*MFF2*CtbHpL(3,3,2)+18*aint25*CddZL*CHpHmZ*
     &  MFF2*CtbHpL(3,3,2)+9*aint8*CddZL*CHpHmZ*MFF2*CtbHpL(3,3,2)+18*
     &  aint28*CddZL*CuuZR*MFF2*CtbHpL(3,3,2)+18*aint29*CddZL*CuuZR*
     &  MFF2*CtbHpL(3,3,2)+18*aint30*CddZL*CuuZR*MFF2*CtbHpL(3,3,2)+9*
     &  aint22*CHpHmZ*CuuZR*MFF2*CtbHpL(3,3,2)+3*aint26*e**2*MFF2*
     &  CtbHpL(3,3,2)+6*aint27*e**2*MFF2*CtbHpL(3,3,2)+3*aint31*e**2*
     &  MFF2*CtbHpL(3,3,2)-6*aint33*e**2*MFF2*CtbHpL(3,3,2)-4*aint35*e*
     &  *2*MFF2*CtbHpL(3,3,2)-4*aint36*e**2*MFF2*CtbHpL(3,3,2)-4*
     &  aint37*e**2*MFF2*CtbHpL(3,3,2)-18*aint28*CddZL*CuuZR*MFp2*
     &  CtbHpL(3,3,2)-18*aint29*CddZL*CuuZR*MFp2*CtbHpL(3,3,2)-18*
     &  aint30*CddZL*CuuZR*MFp2*CtbHpL(3,3,2)-18*aint22*CHpHmZ*CuuZR*
     &  MFp2*CtbHpL(3,3,2)-18*aint23*CHpHmZ*CuuZR*MFp2*CtbHpL(3,3,2)-9*
     &  aint24*CHpHmZ*CuuZR*MFp2*CtbHpL(3,3,2)+12*aint32*e**2*MFp2*
     &  CtbHpL(3,3,2)+12*aint33*e**2*MFp2*CtbHpL(3,3,2)+6*aint34*e**2*
     &  MFp2*CtbHpL(3,3,2)+4*aint35*e**2*MFp2*CtbHpL(3,3,2)+4*aint36*e*
     &  *2*MFp2*CtbHpL(3,3,2)+4*aint37*e**2*MFp2*CtbHpL(3,3,2)+9*
     &  aint23*CHpHmZ*CuuZR*MZ2*CtbHpL(3,3,2)-9*aint21*CddZR*CHpHmZ*
     &  MFF*MFp*CtbHpR(3,3,2)-18*aint25*CddZR*CHpHmZ*MFF*MFp*
     &  CtbHpR(3,3,2)-18*aint8*CddZR*CHpHmZ*MFF*MFp*CtbHpR(3,3,2)+18*
     &  aint22*CHpHmZ*CuuZL*MFF*MFp*CtbHpR(3,3,2)+18*aint23*CHpHmZ*
     &  CuuZL*MFF*MFp*CtbHpR(3,3,2)+9*aint24*CHpHmZ*CuuZL*MFF*MFp*
     &  CtbHpR(3,3,2)-3*aint26*e**2*MFF*MFp*CtbHpR(3,3,2)-6*aint27*e**
     &  2*MFF*MFp*CtbHpR(3,3,2)-6*aint31*e**2*MFF*MFp*CtbHpR(3,3,2)-12*
     &  aint32*e**2*MFF*MFp*CtbHpR(3,3,2)-12*aint33*e**2*MFF*MFp*
     &  CtbHpR(3,3,2)-6*aint34*e**2*MFF*MFp*CtbHpR(3,3,2)+12*aint10*e*
     &  MFF*CHmWpA(2)*CtbWp(3,3)+12*aint13*e*MFF*CHmWpA(2)*CtbWp(3,3)+
     &  12*aint14*e*MFF*CHmWpA(2)*CtbWp(3,3)+6*aint9*e*MFF*CHmWpA(2)*
     &  CtbWp(3,3)+18*aint16*CddZL*MFF*CHmWpZ(2)*CtbWp(3,3)+18*aint18*
     &  CddZL*MFF*CHmWpZ(2)*CtbWp(3,3)+18*aint19*CddZL*MFF*CHmWpZ(2)*
     &  CtbWp(3,3)-18*aint15*CuuZL*MFF*CHmWpZ(2)*CtbWp(3,3)-9*aint21*
     &  CddZR*CHpHmZ*MFp*CtbHpL(3,3,2)*MassFd(3)-18*aint25*CddZR*
     &  CHpHmZ*MFp*CtbHpL(3,3,2)*MassFd(3)-9*aint8*CddZR*CHpHmZ*MFp*
     &  CtbHpL(3,3,2)*MassFd(3)+18*aint29*CddZR*CuuZR*MFp*CtbHpL(3,3,2)
     &  *MassFd(3)-3*aint26*e**2*MFp*CtbHpL(3,3,2)*MassFd(3)-6*aint27*
     &  e**2*MFp*CtbHpL(3,3,2)*MassFd(3)-3*aint31*e**2*MFp*
     &  CtbHpL(3,3,2)*MassFd(3)-4*aint36*e**2*MFp*CtbHpL(3,3,2)*
     &  MassFd(3)+9*aint21*CddZL*CHpHmZ*MFF*CtbHpR(3,3,2)*MassFd(3)+18*
     &  aint25*CddZL*CHpHmZ*MFF*CtbHpR(3,3,2)*MassFd(3)+18*aint28*
     &  CddZL*CuuZL*MFF*CtbHpR(3,3,2)*MassFd(3)+18*aint30*CddZL*CuuZL*
     &  MFF*CtbHpR(3,3,2)*MassFd(3)+3*aint26*e**2*MFF*CtbHpR(3,3,2)*
     &  MassFd(3)+6*aint27*e**2*MFF*CtbHpR(3,3,2)*MassFd(3)-4*aint35*e*
     &  *2*MFF*CtbHpR(3,3,2)*MassFd(3)-4*aint37*e**2*MFF*CtbHpR(3,3,2)*
     &  MassFd(3)+18*aint28*CddZL*CuuZL*MFF*CtbHpL(3,3,2)*MassFu(3)+9*
     &  aint22*CHpHmZ*CuuZL*MFF*CtbHpL(3,3,2)*MassFu(3)+18*aint23*
     &  CHpHmZ*CuuZL*MFF*CtbHpL(3,3,2)*MassFu(3)+9*aint24*CHpHmZ*CuuZL*
     &  MFF*CtbHpL(3,3,2)*MassFu(3)-12*aint32*e**2*MFF*CtbHpL(3,3,2)*
     &  MassFu(3)-6*aint33*e**2*MFF*CtbHpL(3,3,2)*MassFu(3)-6*aint34*e*
     &  *2*MFF*CtbHpL(3,3,2)*MassFu(3)-4*aint35*e**2*MFF*CtbHpL(3,3,2)*
     &  MassFu(3)+18*aint29*CddZR*CuuZR*MFp*CtbHpR(3,3,2)*MassFu(3)+18*
     &  aint30*CddZR*CuuZR*MFp*CtbHpR(3,3,2)*MassFu(3)-18*aint23*
     &  CHpHmZ*CuuZR*MFp*CtbHpR(3,3,2)*MassFu(3)-9*aint24*CHpHmZ*CuuZR*
     &  MFp*CtbHpR(3,3,2)*MassFu(3)+12*aint32*e**2*MFp*CtbHpR(3,3,2)*
     &  MassFu(3)+6*aint34*e**2*MFp*CtbHpR(3,3,2)*MassFu(3)-4*aint36*e*
     &  *2*MFp*CtbHpR(3,3,2)*MassFu(3)-4*aint37*e**2*MFp*CtbHpR(3,3,2)*
     &  MassFu(3)-24*aint14*e*CHmWpA(2)*CtbWp(3,3)*MassFu(3)-36*aint20*
     &  CuuZR*CHmWpZ(2)*CtbWp(3,3)*MassFu(3)-36*aint30*CddZL*CuuZR*
     &  CtbHpR(3,3,2)*MassFd(3)*MassFu(3)+8*aint37*e**2*CtbHpR(3,3,2)*
     &  MassFd(3)*MassFu(3)-9*aint25*CddZL*CHpHmZ*CtbHpL(3,3,2)*
     &  MassHpm2(2)-3*aint27*e**2*CtbHpL(3,3,2)*MassHpm2(2)-36*aint30*
     &  CddZL*CuuZR*CtbHpL(3,3,2)*MFu2(3)+8*aint37*e**2*CtbHpL(3,3,2)*
     &  MFu2(3))/3d0
       Part2=Part2+(-9*aint21*CddZL*CHpHmZ*MFF*MFp*CtbHpL(3,3,2)-18*
     &  aint25*CddZL*CHpHmZ*MFF*MFp*CtbHpL(3,3,2)-18*aint8*CddZL*
     &  CHpHmZ*MFF*MFp*CtbHpL(3,3,2)+18*aint22*CHpHmZ*CuuZR*MFF*MFp*
     &  CtbHpL(3,3,2)+18*aint23*CHpHmZ*CuuZR*MFF*MFp*CtbHpL(3,3,2)+9*
     &  aint24*CHpHmZ*CuuZR*MFF*MFp*CtbHpL(3,3,2)-3*aint26*e**2*MFF*
     &  MFp*CtbHpL(3,3,2)-6*aint27*e**2*MFF*MFp*CtbHpL(3,3,2)-6*aint31*
     &  e**2*MFF*MFp*CtbHpL(3,3,2)-12*aint32*e**2*MFF*MFp*CtbHpL(3,3,2)
     &  -12*aint33*e**2*MFF*MFp*CtbHpL(3,3,2)-6*aint34*e**2*MFF*MFp*
     &  CtbHpL(3,3,2)-9*aint1*CddZR*CHpHmZ*CtbHpR(3,3,2)-36*aint1*
     &  CddZR*CuuZL*CtbHpR(3,3,2)+9*aint2*CHpHmZ*CuuZL*CtbHpR(3,3,2)-6*
     &  aint2*e**2*CtbHpR(3,3,2)+5*aint3*e**2*CtbHpR(3,3,2)-9*aint21*
     &  CddZR*CHpHmZ*MCH2*CtbHpR(3,3,2)-9*aint25*CddZR*CHpHmZ*MCH2*
     &  CtbHpR(3,3,2)-9*aint8*CddZR*CHpHmZ*MCH2*CtbHpR(3,3,2)+18*
     &  aint28*CddZR*CuuZL*MCH2*CtbHpR(3,3,2)-18*aint29*CddZR*CuuZL*
     &  MCH2*CtbHpR(3,3,2)+18*aint30*CddZR*CuuZL*MCH2*CtbHpR(3,3,2)+18*
     &  aint22*CHpHmZ*CuuZL*MCH2*CtbHpR(3,3,2)+18*aint23*CHpHmZ*CuuZL*
     &  MCH2*CtbHpR(3,3,2)+27*aint24*CHpHmZ*CuuZL*MCH2*CtbHpR(3,3,2)-3*
     &  aint26*e**2*MCH2*CtbHpR(3,3,2)-3*aint27*e**2*MCH2*CtbHpR(3,3,2)
     &  -3*aint31*e**2*MCH2*CtbHpR(3,3,2)-12*aint32*e**2*MCH2*
     &  CtbHpR(3,3,2)-12*aint33*e**2*MCH2*CtbHpR(3,3,2)-18*aint34*e**2*
     &  MCH2*CtbHpR(3,3,2)-4*aint35*e**2*MCH2*CtbHpR(3,3,2)+4*aint36*e*
     &  *2*MCH2*CtbHpR(3,3,2)-4*aint37*e**2*MCH2*CtbHpR(3,3,2)+9*
     &  aint21*CddZR*CHpHmZ*MFF2*CtbHpR(3,3,2)+18*aint25*CddZR*CHpHmZ*
     &  MFF2*CtbHpR(3,3,2)+9*aint8*CddZR*CHpHmZ*MFF2*CtbHpR(3,3,2)+18*
     &  aint28*CddZR*CuuZL*MFF2*CtbHpR(3,3,2)+18*aint29*CddZR*CuuZL*
     &  MFF2*CtbHpR(3,3,2)+18*aint30*CddZR*CuuZL*MFF2*CtbHpR(3,3,2)+9*
     &  aint22*CHpHmZ*CuuZL*MFF2*CtbHpR(3,3,2)+3*aint26*e**2*MFF2*
     &  CtbHpR(3,3,2)+6*aint27*e**2*MFF2*CtbHpR(3,3,2)+3*aint31*e**2*
     &  MFF2*CtbHpR(3,3,2)-6*aint33*e**2*MFF2*CtbHpR(3,3,2)-4*aint35*e*
     &  *2*MFF2*CtbHpR(3,3,2)-4*aint36*e**2*MFF2*CtbHpR(3,3,2)-4*
     &  aint37*e**2*MFF2*CtbHpR(3,3,2)-18*aint28*CddZR*CuuZL*MFp2*
     &  CtbHpR(3,3,2)-18*aint29*CddZR*CuuZL*MFp2*CtbHpR(3,3,2)-18*
     &  aint30*CddZR*CuuZL*MFp2*CtbHpR(3,3,2)-18*aint22*CHpHmZ*CuuZL*
     &  MFp2*CtbHpR(3,3,2)-18*aint23*CHpHmZ*CuuZL*MFp2*CtbHpR(3,3,2)-9*
     &  aint24*CHpHmZ*CuuZL*MFp2*CtbHpR(3,3,2)+12*aint32*e**2*MFp2*
     &  CtbHpR(3,3,2)+12*aint33*e**2*MFp2*CtbHpR(3,3,2)+6*aint34*e**2*
     &  MFp2*CtbHpR(3,3,2)+4*aint35*e**2*MFp2*CtbHpR(3,3,2)+4*aint36*e*
     &  *2*MFp2*CtbHpR(3,3,2)+4*aint37*e**2*MFp2*CtbHpR(3,3,2)+9*
     &  aint23*CHpHmZ*CuuZL*MZ2*CtbHpR(3,3,2)-12*aint10*e*MFp*CHmWpA(2)
     &  *CtbWp(3,3)-6*aint11*e*MFp*CHmWpA(2)*CtbWp(3,3)-6*aint12*e*MFp*
     &  CHmWpA(2)*CtbWp(3,3)-6*aint9*e*MFp*CHmWpA(2)*CtbWp(3,3)-18*
     &  aint16*CddZL*MFp*CHmWpZ(2)*CtbWp(3,3)+18*aint15*CuuZL*MFp*
     &  CHmWpZ(2)*CtbWp(3,3)+18*aint17*CuuZL*MFp*CHmWpZ(2)*CtbWp(3,3)+
     &  18*aint20*CuuZL*MFp*CHmWpZ(2)*CtbWp(3,3)+9*aint21*CddZR*CHpHmZ*
     &  MFF*CtbHpL(3,3,2)*MassFd(3)+18*aint25*CddZR*CHpHmZ*MFF*
     &  CtbHpL(3,3,2)*MassFd(3)+18*aint28*CddZR*CuuZR*MFF*CtbHpL(3,3,2)
     &  *MassFd(3)+18*aint30*CddZR*CuuZR*MFF*CtbHpL(3,3,2)*MassFd(3)+3*
     &  aint26*e**2*MFF*CtbHpL(3,3,2)*MassFd(3)+6*aint27*e**2*MFF*
     &  CtbHpL(3,3,2)*MassFd(3)-4*aint35*e**2*MFF*CtbHpL(3,3,2)*
     &  MassFd(3)-4*aint37*e**2*MFF*CtbHpL(3,3,2)*MassFd(3)-9*aint21*
     &  CddZL*CHpHmZ*MFp*CtbHpR(3,3,2)*MassFd(3)-18*aint25*CddZL*
     &  CHpHmZ*MFp*CtbHpR(3,3,2)*MassFd(3)-9*aint8*CddZL*CHpHmZ*MFp*
     &  CtbHpR(3,3,2)*MassFd(3)+18*aint29*CddZL*CuuZL*MFp*CtbHpR(3,3,2)
     &  *MassFd(3)-3*aint26*e**2*MFp*CtbHpR(3,3,2)*MassFd(3)-6*aint27*
     &  e**2*MFp*CtbHpR(3,3,2)*MassFd(3)-3*aint31*e**2*MFp*
     &  CtbHpR(3,3,2)*MassFd(3)-4*aint36*e**2*MFp*CtbHpR(3,3,2)*
     &  MassFd(3)+12*aint12*e*CHmWpA(2)*CtbWp(3,3)*MassFd(3)-36*aint19*
     &  CddZR*CHmWpZ(2)*CtbWp(3,3)*MassFd(3)+18*aint29*CddZL*CuuZL*MFp*
     &  CtbHpL(3,3,2)*MassFu(3)+18*aint30*CddZL*CuuZL*MFp*CtbHpL(3,3,2)
     &  *MassFu(3)-18*aint23*CHpHmZ*CuuZL*MFp*CtbHpL(3,3,2)*MassFu(3)-
     &  9*aint24*CHpHmZ*CuuZL*MFp*CtbHpL(3,3,2)*MassFu(3)+12*aint32*e**
     &  2*MFp*CtbHpL(3,3,2)*MassFu(3)+6*aint34*e**2*MFp*CtbHpL(3,3,2)*
     &  MassFu(3)-4*aint36*e**2*MFp*CtbHpL(3,3,2)*MassFu(3)-4*aint37*e*
     &  *2*MFp*CtbHpL(3,3,2)*MassFu(3)+18*aint28*CddZR*CuuZR*MFF*
     &  CtbHpR(3,3,2)*MassFu(3)+9*aint22*CHpHmZ*CuuZR*MFF*CtbHpR(3,3,2)
     &  *MassFu(3)+18*aint23*CHpHmZ*CuuZR*MFF*CtbHpR(3,3,2)*MassFu(3)+
     &  9*aint24*CHpHmZ*CuuZR*MFF*CtbHpR(3,3,2)*MassFu(3)-12*aint32*e**
     &  2*MFF*CtbHpR(3,3,2)*MassFu(3)-6*aint33*e**2*MFF*CtbHpR(3,3,2)*
     &  MassFu(3)-6*aint34*e**2*MFF*CtbHpR(3,3,2)*MassFu(3)-4*aint35*e*
     &  *2*MFF*CtbHpR(3,3,2)*MassFu(3)-36*aint30*CddZR*CuuZL*
     &  CtbHpL(3,3,2)*MassFd(3)*MassFu(3)+8*aint37*e**2*CtbHpL(3,3,2)*
     &  MassFd(3)*MassFu(3)-9*aint25*CddZR*CHpHmZ*CtbHpR(3,3,2)*
     &  MassHpm2(2)-3*aint27*e**2*CtbHpR(3,3,2)*MassHpm2(2)-36*aint30*
     &  CddZR*CuuZL*CtbHpR(3,3,2)*MFu2(3)+8*aint37*e**2*CtbHpR(3,3,2)*
     &  MFu2(3))/3d0


 
        
        Do I2G4=1,2
        Do I6G4=1,6
       Part1=Part1-3*ChHmHp(I2G4,2,I6G4)*(MFp*aint47(I6G4,I2G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFp*aint48(I6G4,I2G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFp*aint51(I6G4,I2G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFF*aint49(I6G4,I2G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFF*aint50(I6G4,I2G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFF*aint52(I6G4,I2G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,I2G4)-MFF*aint47(I6G4,I2G4)*
     &  CLhFdpFdm(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFp*aint50(I6G4,I2G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,I2G4)+aint51(I6G4,I2G4)*
     &  CLhFdpFdm(3,3,I6G4)*CtbHpL(3,3,I2G4)*MassFd(3)+
     &  aint52(I6G4,I2G4)*CLhFumFup(3,3,I6G4)*CtbHpL(3,3,I2G4)*
     &  MassFu(3))
       Part2=Part2+3*ChHmHp(I2G4,2,I6G4)*(MFF*aint47(I6G4,I2G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,I2G4)+MFp*aint50(I6G4,I2G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,I2G4)-MFp*aint47(I6G4,I2G4)*
     &  CLhFdpFdm(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFp*aint48(I6G4,I2G4)*
     &  CLhFdpFdm(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFp*aint51(I6G4,I2G4)*
     &  CLhFdpFdm(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFF*aint49(I6G4,I2G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFF*aint50(I6G4,I2G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,I2G4)-MFF*aint52(I6G4,I2G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,I2G4)-aint51(I6G4,I2G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpR(3,3,I2G4)*MassFd(3)-
     &  aint52(I6G4,I2G4)*CRhFumFup(3,3,I6G4)*CtbHpR(3,3,I2G4)*
     &  MassFu(3))
       enddo
       enddo

        Do I6G4=1,6
       Part1=Part1-3*(MFF*MFp*aint42(I6G4)*CRhFdpFdm(3,3,I6G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)+MFF*MFp*aint43(I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)+MFF*MFp*
     &  aint46(I6G4)*CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*
     &  CtbHpL(3,3,2)+aint4(I6G4)*CLhFdpFdm(3,3,I6G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)-MFF2*aint42(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)+MCH2*
     &  aint43(I6G4)*CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*
     &  CtbHpR(3,3,2)-MFF2*aint43(I6G4)*CLhFdpFdm(3,3,I6G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)-MFF2*aint46(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)+aint5*
     &  ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*CtbWp(3,3)+MCH2*aint40(I6G4)
     &  *ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*CtbWp(3,3)-MFF2*
     &  aint40(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*CtbWp(3,3)+
     &  MCH2*aint41(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*CtbWp(3,3)
     &  -MFF2*aint41(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*
     &  CtbWp(3,3)+MCH2*aint45(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)
     &  *CtbWp(3,3)-2*MFF2*aint45(I6G4)*ChHpWm(I6G4,2)*
     &  CLhFumFup(3,3,I6G4)*CtbWp(3,3)-2*MFF*MFp*aint38(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)-MFF*MFp*
     &  aint39(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)-2*
     &  MFF*MFp*aint44(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*
     &  CtbWp(3,3)+MFF*aint42(I6G4)*CLhFdpFdm(3,3,I6G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)*MassFd(3)+MFF*aint46(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)*MassFd(3)
     &  +MFp*aint43(I6G4)*CLhFumFup(3,3,I6G4)*CRhFdpFdm(3,3,I6G4)*
     &  CtbHpR(3,3,2)*MassFd(3)-MFF*aint38(I6G4)*ChHpWm(I6G4,2)*
     &  CLhFdpFdm(3,3,I6G4)*CtbWp(3,3)*MassFd(3)-MFF*aint39(I6G4)*
     &  ChHpWm(I6G4,2)*CLhFdpFdm(3,3,I6G4)*CtbWp(3,3)*MassFd(3)-2*MFF*
     &  aint44(I6G4)*ChHpWm(I6G4,2)*CLhFdpFdm(3,3,I6G4)*CtbWp(3,3)*
     &  MassFd(3)+MFp*aint43(I6G4)*CLhFumFup(3,3,I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,2)*MassFu(3)+MFp*aint46(I6G4)*
     &  CLhFumFup(3,3,I6G4)*CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,2)*MassFu(3)
     &  +MFF*aint42(I6G4)*CLhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*
     &  CtbHpR(3,3,2)*MassFu(3)-MFF*aint41(I6G4)*ChHpWm(I6G4,2)*
     &  CRhFumFup(3,3,I6G4)*CtbWp(3,3)*MassFu(3)-2*MFF*aint45(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFumFup(3,3,I6G4)*CtbWp(3,3)*MassFu(3)+
     &  aint46(I6G4)*CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*
     &  CtbHpL(3,3,2)*MassFd(3)*MassFu(3)+aint45(I6G4)*ChHpWm(I6G4,2)*
     &  CLhFumFup(3,3,I6G4)*CtbWp(3,3)*Masshh2(I6G4)+aint46(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)*MFu2(3))
       Part2=Part2-3*(aint4(I6G4)*CRhFdpFdm(3,3,I6G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)-MFF2*aint42(I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)+MCH2*
     &  aint43(I6G4)*CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*
     &  CtbHpL(3,3,2)-MFF2*aint43(I6G4)*CRhFdpFdm(3,3,I6G4)*
     &  CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)-MFF2*aint46(I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)+MFF*MFp*
     &  aint42(I6G4)*CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*
     &  CtbHpR(3,3,2)+MFF*MFp*aint43(I6G4)*CLhFdpFdm(3,3,I6G4)*
     &  CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)+MFF*MFp*aint46(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CLhFumFup(3,3,I6G4)*CtbHpR(3,3,2)+2*MFF*
     &  MFp*aint40(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*CtbWp(3,3)+
     &  MFF*MFp*aint41(I6G4)*ChHpWm(I6G4,2)*CLhFumFup(3,3,I6G4)*
     &  CtbWp(3,3)+2*MFF*MFp*aint45(I6G4)*ChHpWm(I6G4,2)*
     &  CLhFumFup(3,3,I6G4)*CtbWp(3,3)-2*MCH2*aint38(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)-MFF2*aint38(I6G4)
     &  *ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)+2*MFp2*
     &  aint38(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)-3*
     &  MCH2*aint39(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)
     &  +MFp2*aint39(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*
     &  CtbWp(3,3)-aint4(I6G4)*ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*
     &  CtbWp(3,3)-2*MCH2*aint44(I6G4)*ChHpWm(I6G4,2)*
     &  CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)+2*MFp2*aint44(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)-MW2*aint44(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFdpFdm(3,3,I6G4)*CtbWp(3,3)+MFp*aint43(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)*MassFd(3)
     &  +MFF*aint42(I6G4)*CLhFumFup(3,3,I6G4)*CRhFdpFdm(3,3,I6G4)*
     &  CtbHpR(3,3,2)*MassFd(3)+MFF*aint46(I6G4)*CLhFumFup(3,3,I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpR(3,3,2)*MassFd(3)+MFp*aint39(I6G4)*
     &  ChHpWm(I6G4,2)*CLhFdpFdm(3,3,I6G4)*CtbWp(3,3)*MassFd(3)+2*MFp*
     &  aint44(I6G4)*ChHpWm(I6G4,2)*CLhFdpFdm(3,3,I6G4)*CtbWp(3,3)*
     &  MassFd(3)+MFF*aint42(I6G4)*CLhFumFup(3,3,I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CtbHpL(3,3,2)*MassFu(3)+MFp*aint43(I6G4)*
     &  CLhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpR(3,3,2)*MassFu(3)
     &  +MFp*aint46(I6G4)*CLhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*
     &  CtbHpR(3,3,2)*MassFu(3)+MFp*aint40(I6G4)*ChHpWm(I6G4,2)*
     &  CRhFumFup(3,3,I6G4)*CtbWp(3,3)*MassFu(3)+MFp*aint41(I6G4)*
     &  ChHpWm(I6G4,2)*CRhFumFup(3,3,I6G4)*CtbWp(3,3)*MassFu(3)+2*MFp*
     &  aint45(I6G4)*ChHpWm(I6G4,2)*CRhFumFup(3,3,I6G4)*CtbWp(3,3)*
     &  MassFu(3)+aint46(I6G4)*CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*
     &  CtbHpR(3,3,2)*MassFd(3)*MassFu(3)+aint46(I6G4)*
     &  CRhFdpFdm(3,3,I6G4)*CRhFumFup(3,3,I6G4)*CtbHpL(3,3,2)*MFu2(3))
       enddo


		part1=part1*fac/3D0
		part2=part2*fac/3D0

c        dZCHiggs(2,2)=0
c        dv1=0
c        dZbR1=0D0
c        dZbL1=0D0        
c        dZtR1=0D0
c        dZtL1=0D0        


        CTERMS1 =CtbHpL(3,3,2)*(dmt1/Mt-dv1/v-dSinB1/SB)

        CTERMS1 =CTERMS1  + CtbHpL(3,3,2)*dZCHiggs(2,2)/2D0+
     &           CtbHpL(3,3,1)*dZCHiggs(1,2)/2D0

        CTERMS1 =CTERMS1  + CtbHpL(3,3,2)*(dZbL1/2D0+dZtR1/2D0)   
        ! CHW mixing
        CTERMS1 =CTERMS1  +CtbWp(3,3)*MF*dZCHW/MW2
        ! subtraction of deltamb to avoid double counting
        CTERMS2 =CtbHpR(3,3,2)*(dmb1/Mb-dv1/v-dCosB1/CB+deltambEW+deltambEW/tanb**2)

        CTERMS2 =CTERMS2  + CtbHpR(3,3,2)*dZCHiggs(2,2)/2D0+
     &           CtbHpR(3,3,1)*dZCHiggs(1,2)/2D0
        CTERMS2 =CTERMS2  + CtbHpR(3,3,2)*(dZbR1/2D0+dZtL1/2D0)    
        ! CHW mixing
        CTERMS2 =CTERMS2  - CtbWp(3,3)*MFp*dZCHW/MW2

		part1=part1-CTERMS1
		part2=part2-CTERMS2

        MA=Getlambda();
        call IBFunc(FBI,MHpm,MFF,MFP,mA)
        abry1=e**2*(treeL*DCONJG(treeL)+treeR*DCONJG(treeR))
        abry2=e**2*(treeL*DCONJG(treeR)+treeR*DCONJG(treeL))

       realPart=((-26*abry1*FBI(0,0,0,0))/9d0+(8*abry2*MFF*MFP+4*
     &  abry1*(-MCH2+MF2+MFP2))*FBI(1,0,0,0)-(abry1*
     &  FBI(1,0,2,0))/3d0+(abry1*FBI(1,0,3,0))/3d0+4*MCH2*(2*
     &  abry2*MFF*MFP+abry1*(-MCH2+MF2+MFP2))*FBI(1,1,0,0)+(8*(MCH2+
     &  MF2-MFP2)*(2*abry2*MFF*MFP+abry1*(-MCH2+MF2+MFP2))*
     &  FBI(1,2,0,0))/3d0+(2*abry1*FBI(1,2,3,3))/3d0+(16*(2*abry2*
     &  MFF*MFP+abry1*(-MCH2+MF2+MFP2))*FBI(2,0,0,0))/9d0-(14*
     &  abry1*FBI(2,0,1,0))/9d0+(8*abry1*FBI(2,0,3,0))/9d0+(16*
     &  MF2*(2*abry2*MFF*MFP+abry1*(-MCH2+MF2+MFP2))*FBI(2,2,0,0))
     &  /9d0+(4*(2*abry2*MFF*MFP+abry1*(-MCH2+MF2+MFP2))*
     &  FBI(3,0,0,0))/9d0-(17*abry1*FBI(3,0,1,0))/9d0-(7*abry1*
     &  FBI(3,0,2,0))/9d0+(4*(MCH2-MF2+MFP2)*(2*abry2*MFF*MFP+
     &  abry1*(-MCH2+MF2+MFP2))*FBI(3,1,0,0))/3d0+(8*(MCH2-MF2-MFP2)*
     &  (2*abry2*MFF*MFP+abry1*(-MCH2+MF2+MFP2))*FBI(3,2,0,0))/9d0-
     &  (8*abry1*FBI(3,2,1,1))/9d0+(4*MFP2*(2*abry2*MFF*MFP+abry1*(-
     &  MCH2+MF2+MFP2))*FBI(3,3,0,0))/9d0)*3D0


        realPart=realpart/64D0/MHpm/pi**3 


        Cloop=-3*2*DBLE(-2D0*MF*MFP*TreeL*DCONJG(part2)
     &   -2D0*MF*MFP*TreeR*DCONJG(part1)+
     &   (MCH2-MF2-MFP2)*(TreeL*DCONJG(part1)+TreeR*DCONJG(part2)))
        virtEW= Cloop*RPhaseSpace2

        awidth=awidth+realPart+virtEW

#ifdef details
       print*, "==============EW part============="
       print*, "UV, IR", getDelta(), getLambda()
       print*, "MHpm,MFF,MFP",MHpm,MFF,MFP
       print*, "vev", v
       print*, "dZCH",dZCHiggs(2,2),dZCHiggs(2,2)/2D0
       print*, "dZCHiggs(1,2)",dZCHiggs(1,2)
       print*, "dmt1=",dmt1
       print*, "dmb1,deltambEW=",dmb1,deltambEW
       print*, "dZbL1,dZbR1=",dZbL1,dZbR1
       print*, "dZtL1,dZtR1=",dZtL1,dZtR1
       print*, "dv1,dSinB1",dv1,dSinB1
       print*, "loopleft, loopright", part1	, part2
		print*, "CtbHpl(3,3,2),CtbHpR(3,3,2)",CtbHpl(3,3,2),CtbHpR(3,3,2)	
       print*, "|M|^2_tree=", CTREE
	   print*, " Width_tree=",Treepart
        print*, "2*M_tree*M_loop =", Cloop
	   print*, " Width_1loop_vertex=",virtEW
       print*, "Real photon (soft+ hard)", realPart
       print*, "vertex+ real part", realPart+virtEW
       print*, "correction", (realPart+virtEW)/Treepart*100

       print*, "==============QCD+EW part============="
       print*, "awidth", awidth
c        stop
#endif

        endif
        mt=mtsave; mb=mbsave   !recover the stop/sbottom masses
        Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
        Yd(3) = mb*sqrt(2d0)/v/Cos(beta) 
        call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)
        call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
        call couplings
        call couplingsXX

        end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        subroutine Delta_CHtaunuEW(MHp,MFp,awidth,ilevel)
        implicit none 
        integer ilevel,i,j,I6G4,I6G5,I6G6,I2G4,I2G5,I3G4,I5G4,I5G5,
     -          I2G3,I3G3,I5G3,I6G3

        double precision Qs
        double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
        double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
        double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
        double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
        double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
        double precision ZH5(5,5),ZH(6,6)    
        double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

        common /scale/ Qs 
        common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
        common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
        common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
        common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
        common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
        common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

        double precision MHp,MFP,awidth,MCH2,MFP2,realPart,FBI(0:3,0:3,0:3,0:3),
     &                   treepart,RPhaseSpace2,virtpart,mA,dMHout(5,5),dMH6(6,6),
     &                   p2,delcor,CTREE,Divergence,MSv2j
        double complex part2,IC,tree,treeC,deltamb,
     &                 partsum,CTERMS1,CTERMS2,treeL,treeR,Cloop
     &                 ,dZnuL1,dZnuR1,dZtauL1,dZtauR1,dZCH,dZCHW,SelfHpWm
        double precision MHpm1l, Mh1l(5),ZH1l(5,5)
        common /H1loop/ MHpm1l,MH1l,ZH1l
        double precision xiW,xiZ,xiA,xiS3(2),xiS1(6),MW2xiW,MZ2xiZ
        common/gaugeparas/xiW,xiZ,xiA,xiS3,xiS1,MW2xiW,MZ2xiZ
        double precision Masshh2xi(6),MassHpm2xi(2),dMpuregauge(5,5),M2,M3,
     &                   dmtau1,MGL,abry1,abry2
        double complex ZNC(5,5)

        double complex iant1(2),iant2(6),iant3(5,6),iant4,iant5,iant6,iant7(2,5),
     -  iant8(2,5),iant9(2,5),iant10(6),iant11(6),iant12(6),iant13(5,6),iant14(5,6),
     -  iant15(2,5,6),iant16(2,5,6),iant17,iant18,iant19,iant20,iant21,iant22,iant23,
     -  iant24,iant25,iant26,iant27,iant28,iant29,iant30,iant31,iant32,iant33,
     -  iant34(6,2),iant35(6,2),iant36(6,2)

        logical MHpmInput,CPcon,mQrun,phasetest,onelswitch 
        common /switch/ MHpmInput,CPcon,mQrun,onelswitch
#include "looptools.h"  
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"

        call dmtau_EWcnmssm(deltamb,tanb,1)
        do i=1,5
          do j=1,5
        ZNC(i,j)=DCONJG(NN(i,j))
          enddo
        enddo
        IC=(0,1D0)

        MFp=mtau
        MCH2=MHpm**2
        MFp2=MFp**2

        treeR= CtaunuHpR(3,2)

        Ctree=((MCH2-MFP2)*(TreeR*DCONJG(TreeR)))
             
        RPhaseSpace2=sqrt(MCH2**2+MFP2**2-2D0*MCH2*MFP2)/16D0/pi/MHPm**3
        treepart=RPhaseSpace2*Ctree
       if (ilevel.eq.1)then
           awidth=treepart
       else
c start renormalization constant
       dmtau1=0D0
       dZtauR1=0D0
       dZtauL1=0D0
       dZnuL1=0D0
       dZnuR1=0D0
       j=3

       dmtau1=(MFp*(-4*e**2*DBLE(B0i(bb0,MFp2,0D0,MFp2))+2*
     &  (ctautauZL**2-4*ctautauZL*ctautauZR+ctautauZR**2)*
     &  DBLE(B0i(bb0,MFp2,MFp2,MZ2))+4*e**2*DBLE(B0i(bb1,MFp2,0D0,MFp2)
     &  )-g2**2*DBLE(B0i(bb1,MFp2,0D0,MW2))+2*ctautauZL**2*
     &  DBLE(B0i(bb1,MFp2,MZ2,MFp2))+2*ctautauZR**2*
     &  DBLE(B0i(bb1,MFp2,MZ2,MFp2))))/(32d0*Pi**2)
           do I2G3 = 1,2
       dmtau1=dmtau1-(MFp*CtaunuHpR(j,I2G3)**2*
     &  DBLE(B0i(bb1,MFp2,0D0,MassHpm2(I2G3))))/(32d0*Pi**2)
           enddo

           do I6G3 = 1,6
       dmtau1=dmtau1+(MFp*(-((CLhFepFem(j,j,I6G3)+CRhFepFem(j,j,I6G3))*
     &  *2*DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3))))-2*
     &  CLhFepFem(j,j,I6G3)*CRhFepFem(j,j,I6G3)*
     &  DBLE(B0i(bb1,MFp2,Masshh2(I6G3),MFp2))))/(32d0*Pi**2)
           enddo

           do I2G3 = 1,2
           do I3G3 = 1,3
       dmtau1=dmtau1+(-(MFp*DBLE(B0i(bb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  (ctauchastauL(j,I2G3,I3G3)*DCONJG(ctauchastauL(j,I2G3,I3G3))+
     &  ctauchastauR(j,I2G3,I3G3)*DCONJG(ctauchastauR(j,I2G3,I3G3))))+
     &  DBLE(B0i(bb0,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  (ctauchastauR(j,I2G3,I3G3)*DCONJG(ctauchastauL(j,I2G3,I3G3))+
     &  ctauchastauL(j,I2G3,I3G3)*DCONJG(ctauchastauR(j,I2G3,I3G3)))*
     &  MCha(I2G3))/(32d0*Pi**2)
           enddo
           enddo

           do I5G3 = 1,5
           do I6G3 = 1,6
       dmtau1=dmtau1+(-(MFp*DBLE(B0i(bb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  (cchitaustauL(I5G3,j,I6G3)*DCONJG(cchitaustauL(I5G3,j,I6G3))+
     &  cchitaustauR(I5G3,j,I6G3)*DCONJG(cchitaustauR(I5G3,j,I6G3))))+
     &  DBLE(B0i(bb0,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  (cchitaustauR(I5G3,j,I6G3)*DCONJG(cchitaustauL(I5G3,j,I6G3))+
     &  cchitaustauL(I5G3,j,I6G3)*DCONJG(cchitaustauR(I5G3,j,I6G3)))*
     &  MNeu(I5G3))/(32d0*Pi**2)
           enddo
           enddo

       dZtauL1=dZtauL1-(2*e**2*DBLE(B0i(bb0,MFp2,0D0,MFp2))+2*
     &  ctautauZL**2*DBLE(B0i(bb0,MFp2,MFp2,MZ2))+2*e**2*
     &  DBLE(B0i(bb1,MFp2,0D0,MFp2))-g2**2*DBLE(B0i(bb1,MFp2,0D0,MW2))+
     &  2*ctautauZL**2*DBLE(B0i(bb1,MFp2,MZ2,MFp2))-4*e**2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,0D0,MFp2))+2*ctautauZL**2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,MZ2))-8*ctautauZL*ctautauZR*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,MZ2))+2*ctautauZR**2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,MZ2))+4*e**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MFp2))-g2**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MW2))+2*ctautauZL**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MZ2,MFp2))+2*ctautauZR**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MZ2,MFp2)))/(16d0*Pi**2)
           do I2G3 = 1,2
       dZtauL1=dZtauL1+(MFp2*CtaunuHpR(j,I2G3)**2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MassHpm2(I2G3))))/(16d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZtauL1=dZtauL1+(ctauchastauR(j,I2G3,I3G3)*(2*MFp*
     &  DBLE(B0i(bb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  DCONJG(ctauchastauR(j,I2G3,I3G3))+2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  DCONJG(ctauchastauR(j,I2G3,I3G3))-
     &  (DBLE(B0i(bb0,MFp2,MCha2(I2G3),MSv2(I3G3)))+2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MCha2(I2G3),MSv2(I3G3))))*
     &  DCONJG(ctauchastauL(j,I2G3,I3G3))*MCha(I2G3))+
     &  ctauchastauL(j,I2G3,I3G3)*(2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  DCONJG(ctauchastauL(j,I2G3,I3G3))+
     &  (DBLE(B0i(bb0,MFp2,MCha2(I2G3),MSv2(I3G3)))-2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MCha2(I2G3),MSv2(I3G3))))*
     &  DCONJG(ctauchastauR(j,I2G3,I3G3))*MCha(I2G3)))/(32d0*MFp*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZtauL1=dZtauL1+(-(CLhFepFem(j,j,I6G3)**2*
     &  (DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))-2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3)))))+CRhFepFem(j,j,I6G3)**
     &  2*(DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))+2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3))))+2*CLhFepFem(j,j,I6G3)*
     &  CRhFepFem(j,j,I6G3)*(DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))+
     &  DBLE(B0i(bb1,MFp2,Masshh2(I6G3),MFp2))+2*MFp2*
     &  (DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3)))+
     &  DBLE(B0i(dbb1,MFp2,Masshh2(I6G3),MFp2)))))/(32d0*Pi**2)
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZtauL1=dZtauL1+(-(cchitaustauR(I5G3,j,I6G3)*(-2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  DCONJG(cchitaustauR(I5G3,j,I6G3))+
     &  (DBLE(B0i(bb0,MFp2,MNeu2(I5G3),MSe2(I6G3)))+2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MNeu2(I5G3),MSe2(I6G3))))*
     &  DCONJG(cchitaustauL(I5G3,j,I6G3))*MNeu(I5G3)))+
     &  cchitaustauL(I5G3,j,I6G3)*(2*MFp*DBLE(B0i(bb1,MFp2,MNeu2(I5G3)
     &  ,MSe2(I6G3)))*DCONJG(cchitaustauL(I5G3,j,I6G3))+2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  DCONJG(cchitaustauL(I5G3,j,I6G3))+
     &  (DBLE(B0i(bb0,MFp2,MNeu2(I5G3),MSe2(I6G3)))-2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MNeu2(I5G3),MSe2(I6G3))))*
     &  DCONJG(cchitaustauR(I5G3,j,I6G3))*MNeu(I5G3)))/(32d0*MFp*Pi**2)
           enddo
           enddo

       dZtauR1=dZtauR1+(-2*(e**2*(DBLE(B0i(bb0,MFp2,0D0,MFp2))+
     &  DBLE(B0i(bb1,MFp2,0D0,MFp2)))+ctautauZR**2*
     &  (DBLE(B0i(bb0,MFp2,MFp2,MZ2))+DBLE(B0i(bb1,MFp2,MZ2,MFp2))))+4*
     &  e**2*MFp2*DBLE(B0i(dbb0,MFp2,0D0,MFp2))-2*(ctautauZL**2-4*
     &  ctautauZL*ctautauZR+ctautauZR**2)*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,MZ2))-4*e**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MFp2))+g2**2*MFp2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MW2))-2*(ctautauZL**2+ctautauZR**2)*
     &  MFp2*DBLE(B0i(dbb1,MFp2,MZ2,MFp2)))/(16d0*Pi**2)
           do I2G3 = 1,2
       dZtauR1=dZtauR1+(CtaunuHpR(j,I2G3)**2*
     &  (DBLE(B0i(bb1,MFp2,0D0,MassHpm2(I2G3)))+MFp2*
     &  DBLE(B0i(dbb1,MFp2,0D0,MassHpm2(I2G3)))))/(16d0*Pi**2)
           enddo
           do I2G3 = 1,2
           do I3G3 = 1,3
       dZtauR1=dZtauR1+(ctauchastauR(j,I2G3,I3G3)*(2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  DCONJG(ctauchastauR(j,I2G3,I3G3))+
     &  (DBLE(B0i(bb0,MFp2,MCha2(I2G3),MSv2(I3G3)))-2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MCha2(I2G3),MSv2(I3G3))))*
     &  DCONJG(ctauchastauL(j,I2G3,I3G3))*MCha(I2G3))+
     &  ctauchastauL(j,I2G3,I3G3)*(2*MFp*DBLE(B0i(bb1,MFp2,MCha2(I2G3)
     &  ,MSv2(I3G3)))*DCONJG(ctauchastauL(j,I2G3,I3G3))+2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MCha2(I2G3),MSv2(I3G3)))*
     &  DCONJG(ctauchastauL(j,I2G3,I3G3))-
     &  (DBLE(B0i(bb0,MFp2,MCha2(I2G3),MSv2(I3G3)))+2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MCha2(I2G3),MSv2(I3G3))))*
     &  DCONJG(ctauchastauR(j,I2G3,I3G3))*MCha(I2G3)))/(32d0*MFp*Pi**2)
           enddo
           enddo
           do I6G3 = 1,6
       dZtauR1=dZtauR1+(-(CRhFepFem(j,j,I6G3)**2*
     &  (DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))-2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3)))))+CLhFepFem(j,j,I6G3)**
     &  2*(DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))+2*MFp2*
     &  DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3))))+2*CLhFepFem(j,j,I6G3)*
     &  CRhFepFem(j,j,I6G3)*(DBLE(B0i(bb0,MFp2,MFp2,Masshh2(I6G3)))+
     &  DBLE(B0i(bb1,MFp2,Masshh2(I6G3),MFp2))+2*MFp2*
     &  (DBLE(B0i(dbb0,MFp2,MFp2,Masshh2(I6G3)))+
     &  DBLE(B0i(dbb1,MFp2,Masshh2(I6G3),MFp2)))))/(32d0*Pi**2)
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       dZtauR1=dZtauR1+(cchitaustauR(I5G3,j,I6G3)*(2*MFp*
     &  DBLE(B0i(bb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  DCONJG(cchitaustauR(I5G3,j,I6G3))+2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  DCONJG(cchitaustauR(I5G3,j,I6G3))+
     &  (DBLE(B0i(bb0,MFp2,MNeu2(I5G3),MSe2(I6G3)))-2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MNeu2(I5G3),MSe2(I6G3))))*
     &  DCONJG(cchitaustauL(I5G3,j,I6G3))*MNeu(I5G3))-
     &  cchitaustauL(I5G3,j,I6G3)*(-2*MFp*MFp2*
     &  DBLE(B0i(dbb1,MFp2,MNeu2(I5G3),MSe2(I6G3)))*
     &  DCONJG(cchitaustauL(I5G3,j,I6G3))+
     &  (DBLE(B0i(bb0,MFp2,MNeu2(I5G3),MSe2(I6G3)))+2*MFp**2*
     &  DBLE(B0i(dbb0,MFp2,MNeu2(I5G3),MSe2(I6G3))))*
     &  DCONJG(cchitaustauR(I5G3,j,I6G3))*MNeu(I5G3)))/(32d0*MFp*Pi**2)
           enddo
           enddo


       dZnuL1=((CW2*g2**2+g1*(2*CW*g2*SW+g1*SW2))*
     &  DBLE(B0i(bb1,0D0,0D0,MZ2))-2*g2**2*(DBLE(B0i(bb0,0D0,MW2,MFe2(j))
     &  )+DBLE(B0i(bb1,0D0,MW2,MFe2(j)))))/(32d0*Pi**2)
           do I2G3 = 1,2
       dZnuL1=dZnuL1-(CtaunuHpR(j,I2G3)**2*
     &  (DBLE(B0i(bb0,0D0,MassHpm2(I2G3),MFe2(j)))+
     &  DBLE(B0i(bb1,0D0,MassHpm2(I2G3),MFe2(j)))))/(16d0*Pi**2)
           enddo
           do I5G3 = 1,5
       dZnuL1=dZnuL1+(cchinusnu(I5G3,j)*DBLE(B0i(bb1,0D0,MNeu2(I5G3)
     &  ,MSv2(j)))*(g1*ZNC(I5G3,1)-g2*ZNC(I5G3,2)))/(16d0*Pi**
     &  2*Sqrt2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       dZnuL1=dZnuL1+(CF12F1S12(I2G3,j,I6G3)*
     &  DBLE(B0i(bb1,0D0,MCha2(I2G3),MSe2(I6G3)))*
     &  DCONJG(CF12F1S12(I2G3,j,I6G3)))/(16d0*Pi**2)
           enddo
           enddo
        dZCHiggs(2,2)=     dZCH()
        dZCHW=SelfHpWm()
c end renormalization constant

       Divergence= Getdelta()
        MSv2j=MSv2(j)
        Do I2G4=1,2
       iant1(I2G4)=B0i(bb0,MFp2,MSv2j,MCha2(I2G4))
        enddo
        Do I6G4=1,6
       iant2(I6G4)=B0i(bb0,MFp2,MFp2,Masshh2(I6G4))
       iant10(I6G4)=C0i(cc2,MCH2,MFp2,0D0,MW2,Masshh2(I6G4),MFp2)
       iant11(I6G4)=C0i(cc0,MCH2,MFp2,0D0,MW2,Masshh2(I6G4),MFp2)
       iant12(I6G4)=C0i(cc1,MCH2,MFp2,0D0,MW2,Masshh2(I6G4),MFp2)
        enddo
        Do I5G4=1,5
        Do I6G4=1,6
       iant3(I5G4,I6G4)=B0i(bb0,MFp2,MNeu2(I5G4),MSe2(I6G4))
       iant13(I5G4,I6G4)=C0i(cc1,MFp2,MCH2,0D0,MNeu2(I5G4),MSe2(I6G4),MSv2j)
       iant14(I5G4,I6G4)=C0i(cc0,MFp2,MCH2,0D0,MNeu2(I5G4),MSe2(I6G4),MSv2j)
        enddo
        enddo
       iant4=B0i(bb0,MFp2,0D0,MCH2)
       iant5=B0i(bb0,MFp2,0D0,MFp2)
       iant6=B0i(bb0,MFp2,MFp2,MZ2)
       iant17=C0i(cc0,MCH2,0D0,MFp2,0D0,MW2,MFp2)
       iant18=C0i(cc1,MCH2,0D0,MFp2,0D0,MW2,MFp2)
       iant19=C0i(cc2,MCH2,0D0,MFp2,0D0,MW2,MFp2)
       iant20=C0i(cc0,MCH2,MFp2,0D0,MW2,MZ2,MFp2)
       iant21=C0i(cc1,MCH2,MFp2,0D0,MW2,MZ2,MFp2)
       iant22=C0i(cc1,MFp2,MCH2,0D0,0D0,MW2,MZ2)
       iant23=C0i(cc1,0D0,MFp2,MCH2,0D0,MZ2,MFp2)
       iant24=C0i(cc2,0D0,MFp2,MCH2,0D0,MZ2,MFp2)
       iant25=C0i(cc0,MCH2,0D0,MFp2,0D0,MCH2,MFp2)
       iant26=C0i(cc1,MCH2,0D0,MFp2,0D0,MCH2,MFp2)
       iant27=C0i(cc2,MCH2,0D0,MFp2,0D0,MCH2,MFp2)
       iant28=C0i(cc1,0D0,MCH2,MFp2,0D0,MZ2,MCH2)
       iant29=C0i(cc0,0D0,MCH2,MFp2,0D0,MZ2,MCH2)
       iant30=C0i(cc2,0D0,MCH2,MFp2,0D0,MZ2,MCH2)
       iant31=C0i(cc0,MCH2,0D0,MFp2,MZ2,MCH2,MFp2)
       iant32=C0i(cc1,MCH2,0D0,MFp2,MZ2,MCH2,MFp2)
       iant33=C0i(cc2,MCH2,0D0,MFp2,MZ2,MCH2,MFp2)
        Do I2G4=1,2
        Do I5G4=1,5
       iant7(I2G4,I5G4)=C0i(cc1,MCH2,0D0,MFp2,MCha2(I2G4),MNeu2(I5G4),MSv2j)
       iant8(I2G4,I5G4)=C0i(cc2,MCH2,0D0,MFp2,MCha2(I2G4),MNeu2(I5G4),MSv2j)
       iant9(I2G4,I5G4)=C0i(cc0,MCH2,0D0,MFp2,MCha2(I2G4),MNeu2(I5G4),MSv2j)
        enddo
        enddo
        Do I2G4=1,2
        Do I5G4=1,5
        Do I6G4=1,6
       iant15(I2G4,I5G4,I6G4)=C0i(cc1,MCH2,MFp2,0D0,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSe2(I6G4))
       iant16(I2G4,I5G4,I6G4)=C0i(cc0,MCH2,MFp2,0D0,MCha2(I2G4)
     &  ,MNeu2(I5G4),MSe2(I6G4))
        enddo
        enddo
        enddo
        Do I6G4=1,6
        Do I2G4=1,2
       iant34(I6G4,I2G4)=C0i(cc1,MCH2,0D0,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFp2)
       iant35(I6G4,I2G4)=C0i(cc2,MCH2,0D0,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFp2)
       iant36(I6G4,I2G4)=C0i(cc0,MCH2,0D0,MFp2,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MFp2)
        enddo
        enddo

        part2=0D0
        Do I2G4=1,2
        Do I5G4=1,5
        Do I6G4=1,6
       Part2=Part2-(IC*CF12F1S12(I2G4,j,I6G4)*(MCH2*
     &  cchitaustauR(I5G4,j,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  iant15(I2G4,I5G4,I6G4)+cchitaustauR(I5G4,j,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*iant3(I5G4,I6G4)+
     &  cchitaustauL(I5G4,j,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  iant15(I2G4,I5G4,I6G4)*MassFe(j)*MCha(I2G4)+
     &  cchitaustauL(I5G4,j,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  iant16(I2G4,I5G4,I6G4)*MassFe(j)*MCha(I2G4)+
     &  cchitaustauR(I5G4,j,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  iant16(I2G4,I5G4,I6G4)*MCha2(I2G4)+cchitaustauL(I5G4,j,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*iant15(I2G4,I5G4,I6G4)*MassFe(j)*
     &  MNeu(I5G4)+cchitaustauR(I5G4,j,I6G4)*CRHpChiCha(I5G4,I2G4,2)*
     &  iant16(I2G4,I5G4,I6G4)*MCha(I2G4)*MNeu(I5G4)))
       enddo
       enddo
       enddo
        Do I2G4=1,2
        Do I5G4=1,5
       Part2=Part2-(IC*cchinusnu(I5G4,j)*(CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauL(j,I2G4,j))*iant1(I2G4)-MCH2*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(ctauchastauL(j,I2G4,j))*
     &  iant7(I2G4,I5G4)-MCH2*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauL(j,I2G4,j))*iant8(I2G4,I5G4)-MCH2*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(ctauchastauL(j,I2G4,j))*
     &  iant9(I2G4,I5G4)-CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauR(j,I2G4,j))*iant7(I2G4,I5G4)*MassFe(j)*
     &  MCha(I2G4)-CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauR(j,I2G4,j))*iant8(I2G4,I5G4)*MassFe(j)*
     &  MCha(I2G4)-CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauR(j,I2G4,j))*iant9(I2G4,I5G4)*MassFe(j)*
     &  MCha(I2G4)-CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauR(j,I2G4,j))*iant7(I2G4,I5G4)*MassFe(j)*
     &  MNeu(I5G4)-CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauR(j,I2G4,j))*iant8(I2G4,I5G4)*MassFe(j)*
     &  MNeu(I5G4)+CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(ctauchastauL(j,I2G4,j))*iant9(I2G4,I5G4)*MCha(I2G4)*
     &  MNeu(I5G4)+CLHpChiCha(I5G4,I2G4,2)*DCONJG(ctauchastauL(j,I2G4,j))
     &  *iant9(I2G4,I5G4)*MNeu2(I5G4)))
       enddo
       enddo
        Do I2G4=1,2
        Do I6G4=1,6
       Part2=Part2-(ChHmHp(I2G4,2,I6G4)*(CLhFepFem(j,j,I6G4)*
     &  iant34(I6G4,I2G4)+CLhFepFem(j,j,I6G4)*iant35(I6G4,I2G4)+
     &  CLhFepFem(j,j,I6G4)*iant36(I6G4,I2G4)+CRhFepFem(j,j,I6G4)*
     &  iant36(I6G4,I2G4))*MassFe(j)*Ye(j)*ZP(I2G4,1))
       enddo
       enddo
        Do I5G4=1,5
        Do I6G4=1,6
       Part2=Part2+IC*cchinusnu(I5G4,j)*CHpSemSv(I6G4,j,2)*
     &  (cchitaustauL(I5G4,j,I6G4)*iant13(I5G4,I6G4)*MassFe(j)-
     &  cchitaustauR(I5G4,j,I6G4)*iant14(I5G4,I6G4)*MNeu(I5G4))
       enddo
       enddo
        Do I6G4=1,6
       Part2=Part2-((g2*ChHpWm(I6G4,2)*(-2*MCH2*CRhFepFem(j,j,I6G4)*
     &  iant10(I6G4)+2*MFp2*CRhFepFem(j,j,I6G4)*iant10(I6G4)+2*MFp2*
     &  CLhFepFem(j,j,I6G4)*iant11(I6G4)-2*MCH2*CRhFepFem(j,j,I6G4)*
     &  iant11(I6G4)+2*MFp2*CRhFepFem(j,j,I6G4)*iant11(I6G4)-MW2*
     &  CRhFepFem(j,j,I6G4)*iant11(I6G4)+MFp2*CLhFepFem(j,j,I6G4)*
     &  iant12(I6G4)-3*MCH2*CRhFepFem(j,j,I6G4)*iant12(I6G4)+MFp2*
     &  CRhFepFem(j,j,I6G4)*iant12(I6G4)-CRhFepFem(j,j,I6G4)*
     &  iant2(I6G4)))/Sqrt2)
       enddo
       Part2=Part2+(2*e*g2*iant17*sqrt2*CHmWpA(2)*MassFe(j)-2*e*g2*
     &  iant18*sqrt2*CHmWpA(2)*MassFe(j)-2*e*g2*iant19*sqrt2*CHmWpA(2)*
     &  MassFe(j)-4*ctautauZR*g2*iant20*sqrt2*CHmWpZ(2)*MassFe(j)-2*
     &  ctautauZL*g2*iant21*sqrt2*CHmWpZ(2)*MassFe(j)+CW*g2**2*iant22*
     &  sqrt2*CHmWpZ(2)*MassFe(j)+g1*g2*iant22*sqrt2*SW*CHmWpZ(2)*
     &  MassFe(j)-CHpHmZ*CW*g2*iant4*Ye(j)*ZP(2,1)-2*e**2*iant5*Ye(j)*
     &  ZP(2,1)-2*CHpHmZ*ctautauZR*iant6*Ye(j)*ZP(2,1)+4*ctautauZR*CW*
     &  g2*iant6*Ye(j)*ZP(2,1)+2*ctautauZR*CW*g2*iant23*MCH2*Ye(j)*
     &  ZP(2,1)+4*ctautauZR*CW*g2*iant24*MCH2*Ye(j)*ZP(2,1)-4*e**2*
     &  iant25*MCH2*Ye(j)*ZP(2,1)-2*e**2*iant26*MCH2*Ye(j)*ZP(2,1)-2*e*
     &  *2*iant27*MCH2*Ye(j)*ZP(2,1)+2*CHpHmZ*CW*g2*iant28*MCH2*Ye(j)*
     &  ZP(2,1)-CHpHmZ*CW*g2*iant30*MCH2*Ye(j)*ZP(2,1)-4*CHpHmZ*
     &  ctautauZR*iant31*MCH2*Ye(j)*ZP(2,1)-2*CHpHmZ*ctautauZR*iant32*
     &  MCH2*Ye(j)*ZP(2,1)-2*CHpHmZ*ctautauZR*iant33*MCH2*Ye(j)*ZP(2,1)
     &  -2*ctautauZR*CW*g2*iant23*MFp2*Ye(j)*ZP(2,1)-2*ctautauZL*CW*g2*
     &  iant24*MFp2*Ye(j)*ZP(2,1)-4*e**2*iant25*MFp2*Ye(j)*ZP(2,1)-2*e*
     &  *2*iant26*MFp2*Ye(j)*ZP(2,1)-2*e**2*iant27*MFp2*Ye(j)*ZP(2,1)-
     &  2*CHpHmZ*CW*g2*iant28*MFp2*Ye(j)*ZP(2,1)-CHpHmZ*CW*g2*iant30*
     &  MFp2*Ye(j)*ZP(2,1)-4*CHpHmZ*ctautauZL*iant31*MFp2*Ye(j)*ZP(2,1)
     &  -2*CHpHmZ*ctautauZL*iant32*MFp2*Ye(j)*ZP(2,1)-2*CHpHmZ*
     &  ctautauZL*iant33*MFp2*Ye(j)*ZP(2,1)-CHpHmZ*CW*g2*iant29*MZ2*
     &  Ye(j)*ZP(2,1)-CHpHmZ*g1*iant4*SW*Ye(j)*ZP(2,1)+4*ctautauZR*g1*
     &  iant6*SW*Ye(j)*ZP(2,1)+2*ctautauZR*g1*iant23*MCH2*SW*Ye(j)*
     &  ZP(2,1)+4*ctautauZR*g1*iant24*MCH2*SW*Ye(j)*ZP(2,1)+2*CHpHmZ*
     &  g1*iant28*MCH2*SW*Ye(j)*ZP(2,1)-CHpHmZ*g1*iant30*MCH2*SW*Ye(j)*
     &  ZP(2,1)-2*ctautauZR*g1*iant23*MFp2*SW*Ye(j)*ZP(2,1)-2*
     &  ctautauZL*g1*iant24*MFp2*SW*Ye(j)*ZP(2,1)-2*CHpHmZ*g1*iant28*
     &  MFp2*SW*Ye(j)*ZP(2,1)-CHpHmZ*g1*iant30*MFp2*SW*Ye(j)*ZP(2,1)-
     &  CHpHmZ*g1*iant29*MZ2*SW*Ye(j)*ZP(2,1))/2d0


		part2=part2*fac

        CTERMS2 =CtaunuHpR(3,2)*(dmtau1/MFP-dv1/v-dCosB1/CB)
        CTERMS2 =CTERMS2  + CtaunuHpR(3,2)*dZCHiggs(2,2)/2D0+
     &           CtaunuHpR(3,1)*dZCHiggs(1,2)/2D0
        CTERMS2 =CTERMS2  + CtaunuHpR(3,2)*(dZtauR1/2D0+dZnuL1/2D0)
c CHW mixing
        CTERMS2 =CTERMS2  - g2/sqrt2*MFp*dZCHW/MW2
c subtract deltab correction
        CTERMS2 =CtaunuHpR(3,2)*(deltamb+deltamb/tanb**2)
		part2=part2-CTERMS2
        MA=Getlambda();
        call IBFunc(FBI,MHpm,0D0,MFP,mA)
        abry1=e**2*(treeR*DCONJG(treeR))

       realPart=-2*abry1*FBI(0,0,0,0)+4*abry1*(-MCH2+MFP2)*
     &  FBI(1,0,0,0)+4*abry1*MCH2*(-MCH2+MFP2)*FBI(1,1,0,0)+4*
     &  abry1*(-MCH2+MFP2)*FBI(3,0,0,0)-2*abry1*FBI(3,0,1,0)+4*
     &  abry1*(-MCH2**2+MFP2**2)*FBI(3,1,0,0)+4*abry1*MFP2*(-MCH2+
     &  MFP2)*FBI(3,3,0,0)

c       print*,"FBI",FBI(0,0,0,0),FBI(1,0,0,0),FBI(1,1,0,0),FBI(3,0,0,0),FBI(3,0,1,0),
c     -  FBI(3,1,0,0),FBI(3,3,0,0)
c       stop
        realPart=realpart/64D0/MHpm/pi**3 


        Cloop=-2*DBLE(
     &   (MCH2-MFP2)*(TreeR*DCONJG(part2)))
        virtpart= Cloop*RPhaseSpace2
        awidth=treepart+virtpart+realpart
#ifdef details
       print*, "==============EW part============="
       print*, "charged Higgs(+) -> tau(+) + neu_tau"
       print*, "UV, IR", getDelta(), getLambda()
       print*, "MHpm,MFP,MassFe(j)",MHpm,MFP,MassFe(j)
       print*, "dZCH",dZCHiggs(2,2),dZCHiggs(2,2)/2D0
       print*, "dZCHW,dze1",dZCHW,dze1
       print*, "dZCHiggs(1,2)",dZCHiggs(1,2)
       print*, "dmtau1=",dmtau1
       print*, "dmnu1=",0D0
       print*, "deltamb",deltamb
       print*, "dZtauL1,dZtauR1=",dZtauL1,dZtauR1
       print*, "dZnuL1=",dZnuL1
       print*, "dv1=",dv1, dv1/v
       print*, "dCosB1=",dCosB1
       print*, "loopleft, loopright",0D0	, part2
       print*, "|M|^2_tree=", CTREE
	   print*, " Width_tree=",Treepart
        print*, "2*M_tree*M_loop =", Cloop
	   print*, " Width_1loop_vertex=",virtpart
       print*, "Real photon (soft+ hard)", realPart
       print*, "vertex+ real part", realPart+virtpart
       print*, "RPhaseSpace2",RPhaseSpace2

c		stop
#endif
        endif
        end subroutine Delta_CHtaunuEW
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        subroutine Delta_CHchaneuEW(MHp,MX1,MX2,iin,jin,awidth,ischeme,ilevel)
        implicit none 
        integer ischeme,ilevel,iin,jin,I6G4,I6G5,I6G6,I2G4,I2G5,I3G4,I5G4,I5G5,
     -          I2G3,I3G3,I5G3,I6G3,i,j,I3G5,ik

        double precision Qs
        double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
        double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
        double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
        double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
        double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
        double precision ZH5(5,5),ZH(6,6)    
        double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

        common /scale/ Qs 
        common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
        common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
        common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
        common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
        common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
        common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
        common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

        double precision MHp,MX1,MX2,awidth,MCH2,MX12,MX22,realPart,
     &                   treepart,RPhaseSpace2,virtpart,mA,dMHout(5,5),dMH6(6,6),
     &                   CTREE,FBI(0:3,0:3,0:3,0:3),CLOOP,virtEW,
     &                   abrx(6),rcheck,demass1,demass2
        double complex part1,part2,IC,treeL,treeR,CTERMSL,CTERMSR
        double complex ZNC(5,5),lam,expeta,dZCH,dZCHW,SelfHpWm

        logical MHpmInput,CPcon,mQrun,phasetest,onelswitch 
        common /switch/ MHpmInput,CPcon,mQrun,onelswitch

        double complex ant1,ant2(2),ant3(5),ant4(5),ant5(2),ant6(2,2),ant7(2),
     -  ant8(3,6),ant9(3,6),ant10(3,6),ant11(6,5),ant12(6,5),ant13(3),ant14,ant15,
     -  ant16,ant17,ant18,ant19,ant20(2),ant21(2),ant22(2),ant23(2),ant24(2),
     -  ant25(2),ant26(5),ant27(5),ant28(5),ant29(5),ant30(5),ant31(5),ant32(2,5),
     -  ant33(2,5),ant34(2,5),ant35(2,5),ant36(2,5),ant37(2,5),ant38(2,2,5),
     -  ant39(2,2,5),ant40(2,2,5),ant41(6,2),ant42(6,2),ant43(6,2),ant44(6,2,2),
     -  ant45(6,2,2),ant46(6,2,2),ant47(6,3),ant48(6,3),ant49(3,6),ant50(3,6),
     -  ant51(3,6,3),ant52(3,6,3),ant53(3,6,3),ant54(3,3,6),ant55(3,3,6),
     -  ant56(3,3,6),ant57(3,3,6),ant58(3,3,6),ant59(3,3,6),ant60(6,5),ant61(6,5),
     -  ant62(6,5),ant63(6,2,5),ant64(6,2,5),ant65(6,2,5),ant66(6,2,5),
     -  ant67(6,2,5),ant68(6,2,5),ant69(3,6,6),ant70(3,6,6),ant71(3,6,6),
     -  ant72(3,6,6),ant73(3,6,6),ant74(3,6,6),ant75(3,3),ant76(3,3),ant77(3,3)

      double precision dabsMino1,dabsMino2,dabsMino3,dUVabsMino1,
     &                 dUVabsMino2,dUVabsMino3,dUVabsMUE1
      double precision MChiOS1L(5),MChaOS1L(2),MChiOS1Lapr1(5),MChaOS1Lapr1(2),
     &                 MChiOS1Lapr2(5),MChaOS1Lapr2(2),MChiOS1Lapr3(5),
     &                 MChaOS1Lapr3(2),MChiOS1Lapr4(5),MChaOS1Lapr4(2)
      double complex dMchi(5,5),dMcha(2,2),dMchiDR(5,5),dMchaDR(2,2),dZNeuL(5,5),
     &               dZNeuLb(5,5),dZNeuR(5,5),dZNeuRb(5,5),dZChaL(2,2),
     &               dZChaLb(2,2),dZChaR(2,2),dZChaRb(2,2),dUVMchi(5,5),dUVMcha(2,2)
     &               ,dUVZNeuL(5,5),dUVZNeuLb(5,5),dUVZNeuR(5,5),dUVZNeuRb(5,5)
     &               ,dUVZChaL(2,2),dUVZChaLb(2,2),dUVZChaR(2,2),dUVZChaRb(2,2)

      common/CTGaugino/dabsMino1,dabsMino2,dabsMino3,dUVabsMino1,
     &                 dUVabsMino2,dUVabsMino3,dMChi,dMcha,dMchiDR,dMchaDR,dZNeuL,
     &                 dZNeuLb,dZNeuR,dZNeuRb,dZChaL,
     &                 dZChaLb,dZChaR,dZChaRb,dUVMchi,dUVMcha
     &                 ,dUVZNeuL,dUVZNeuLb,dUVZNeuR,dUVZNeuRb
     &                 ,dUVZChaL,dUVZChaLb,dUVZChaR,dUVZChaRb
      common/Gaugino1Lmass/MChiOS1L,MChaOS1L,MChiOS1Lapr1,MChaOS1Lapr1,
     &                 MChiOS1Lapr2,MChaOS1Lapr2,MChiOS1Lapr3,
     &                 MChaOS1Lapr3,MChiOS1Lapr4,MChaOS1Lapr4

#include "looptools.h"  
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"

        MX12=MX1**2; MX22=MX2**2; MCH2=MHpm**2
        do i=1,5
          do j=1,5
        ZNC(i,j)=DCONJG(NN(i,j))
          enddo
        enddo
        IC=(0,1D0)
        lam= abslambda*(cos(phil) + IC*sin(phil))
        expeta= Cos(phiu)+ IC*sin(phiu)
        treeL= -IC*CLHpChiCha(jin,iin,2)
        treeR= -IC*CRHpChiCha(jin,iin,2)

        Ctree=-2D0*MX1*MX2*TreeL*DCONJG(TreeR)
     &   -2D0*MX1*MX2*TreeR*DCONJG(TreeL)+
     &   (MCH2-MX12-MX22)*(TreeL*DCONJG(TreeL)+TreeR*DCONJG(TreeR))

        RPhaseSpace2=sqrt(MCH2**2+MX12**2+MX22**2
     &   -2D0*MCH2*MX12-2D0*MCH2*MX22-2D0*MX12*MX22)/16D0/pi/MHpm**3
        treepart=RPhaseSpace2*Ctree
       if(ilevel.eq.1)then
         awidth=treepart
         return
       else
       ant1=B0i(bb0,MX22,MCH2,MX12)
       ant14=C0i(cc0,MCH2,MX22,MX12,0D0,MW2,MX12)
       ant15=C0i(cc2,MCH2,MX22,MX12,0D0,MW2,MX12)
       ant16=C0i(cc1,MCH2,MX22,MX12,0D0,MW2,MX12)
       ant17=C0i(cc0,MCH2,MX22,MX12,0D0,MCH2,MX12)
       ant18=C0i(cc1,MCH2,MX22,MX12,0D0,MCH2,MX12)
       ant19=C0i(cc2,MCH2,MX22,MX12,0D0,MCH2,MX12)
        Do I2G4=1,2
       ant2(I2G4)=B0i(bb0,MX22,MCH2,MCha2(I2G4))
       ant5(I2G4)=B0i(bb0,MX22,MW2,MCha2(I2G4))
       ant7(I2G4)=B0i(bb0,MX22,MW2,MCha2(I2G4))
       ant20(I2G4)=C0i(cc1,MCH2,MX12,MX22,MW2,MZ2,MCha2(I2G4))
       ant21(I2G4)=C0i(cc2,MCH2,MX12,MX22,MW2,MZ2,MCha2(I2G4))
       ant22(I2G4)=C0i(cc0,MCH2,MX12,MX22,MW2,MZ2,MCha2(I2G4))
       ant23(I2G4)=C0i(cc2,MCH2,MX22,MX12,MZ2,MCH2,MCha2(I2G4))
       ant24(I2G4)=C0i(cc1,MCH2,MX22,MX12,MZ2,MCH2,MCha2(I2G4))
       ant25(I2G4)=C0i(cc0,MCH2,MX22,MX12,MZ2,MCH2,MCha2(I2G4))
        enddo
        Do I5G4=1,5
       ant3(I5G4)=B0i(bb0,MX22,MZ2,MNeu2(I5G4))
       ant4(I5G4)=B0i(bb0,MX22,MZ2,MNeu2(I5G4))
       ant26(I5G4)=C0i(cc2,MCH2,MX22,MX12,MW2,MZ2,MNeu2(I5G4))
       ant27(I5G4)=C0i(cc1,MCH2,MX22,MX12,MW2,MZ2,MNeu2(I5G4))
       ant28(I5G4)=C0i(cc0,MCH2,MX22,MX12,MW2,MZ2,MNeu2(I5G4))
       ant29(I5G4)=C0i(cc1,MCH2,MX12,MX22,MZ2,MCH2,MNeu2(I5G4))
       ant30(I5G4)=C0i(cc0,MCH2,MX12,MX22,MZ2,MCH2,MNeu2(I5G4))
       ant31(I5G4)=C0i(cc2,MCH2,MX12,MX22,MZ2,MCH2,MNeu2(I5G4))
        enddo
        Do I2G5=1,2
        Do I2G4=1,2
       ant6(I2G5,I2G4)=B0i(bb0,MX22,MassHpm2(I2G5),MCha2(I2G4))
        enddo
        enddo
        Do I3G4=1,3
        Do I6G4=1,6
       ant8(I3G4,I6G4)=B0i(bb0,MX22,MFe2(I3G4),MSe2(I6G4))
       ant47(I6G4,I3G4)=C0i(cc1,MX12,MCH2,MX22,0D0,MSe2(I6G4),MSv2(I3G4))
       ant48(I6G4,I3G4)=C0i(cc2,MX12,MCH2,MX22,0D0,MSe2(I6G4),MSv2(I3G4))
       ant49(I3G4,I6G4)=C0i(cc2,MCH2,MX22,MX12,0D0,MFe2(I3G4),MSe2(I6G4))
       ant50(I3G4,I6G4)=C0i(cc1,MCH2,MX22,MX12,0D0,MFe2(I3G4),MSe2(I6G4))
        enddo
        enddo
        Do I3G5=1,3
        Do I6G4=1,6
       ant9(I3G5,I6G4)=B0i(bb0,MX22,MFu2(I3G5),MSu2(I6G4))
       ant10(I3G5,I6G4)=B0i(bb0,MX22,MFd2(I3G5),MSd2(I6G4))
        enddo
        enddo
        Do I6G4=1,6
        Do I5G4=1,5
       ant11(I6G4,I5G4)=B0i(bb0,MX22,Masshh2(I6G4),MNeu2(I5G4))
       ant12(I6G4,I5G4)=B0i(bb0,MX22,Masshh2(I6G4),MNeu2(I5G4))
       ant60(I6G4,I5G4)=C0i(cc1,MCH2,MX22,MX12,MW2,Masshh2(I6G4),MNeu2(I5G4))
       ant61(I6G4,I5G4)=C0i(cc0,MCH2,MX22,MX12,MW2,Masshh2(I6G4),MNeu2(I5G4))
       ant62(I6G4,I5G4)=C0i(cc2,MCH2,MX22,MX12,MW2,Masshh2(I6G4),MNeu2(I5G4))
        enddo
        enddo
        Do I3G4=1,3
       ant13(I3G4)=B0i(bb0,MX22,0D0,MSv2(I3G4))
        enddo
        Do I2G4=1,2
        Do I5G4=1,5
       ant32(I2G4,I5G4)=C0i(cc2,MX12,MCH2,MX22,MZ2,MCha2(I2G4),MNeu2(I5G4))
       ant33(I2G4,I5G4)=C0i(cc2,MX22,MCH2,MX12,MW2,MCha2(I2G4),MNeu2(I5G4))
       ant34(I2G4,I5G4)=C0i(cc1,MX12,MCH2,MX22,MZ2,MCha2(I2G4),MNeu2(I5G4))
       ant35(I2G4,I5G4)=C0i(cc0,MX12,MCH2,MX22,MZ2,MCha2(I2G4),MNeu2(I5G4))
       ant36(I2G4,I5G4)=C0i(cc1,MX22,MCH2,MX12,MW2,MCha2(I2G4),MNeu2(I5G4))
       ant37(I2G4,I5G4)=C0i(cc0,MX22,MCH2,MX12,MW2,MCha2(I2G4),MNeu2(I5G4))
        enddo
        enddo
        Do I2G5=1,2
        Do I2G4=1,2
        Do I5G4=1,5
       ant38(I2G5,I2G4,I5G4)=C0i(cc1,MX22,MCH2,MX12,MassHpm2(I2G5)
     &  ,MCha2(I2G4),MNeu2(I5G4))
       ant39(I2G5,I2G4,I5G4)=C0i(cc2,MX22,MCH2,MX12,MassHpm2(I2G5)
     &  ,MCha2(I2G4),MNeu2(I5G4))
       ant40(I2G5,I2G4,I5G4)=C0i(cc0,MX22,MCH2,MX12,MassHpm2(I2G5)
     &  ,MCha2(I2G4),MNeu2(I5G4))
        enddo
        enddo
        enddo
        Do I6G4=1,6
        Do I2G4=1,2
       ant41(I6G4,I2G4)=C0i(cc0,MCH2,MX12,MX22,MW2,Masshh2(I6G4),MCha2(I2G4))
       ant42(I6G4,I2G4)=C0i(cc1,MCH2,MX12,MX22,MW2,Masshh2(I6G4),MCha2(I2G4))
       ant43(I6G4,I2G4)=C0i(cc2,MCH2,MX12,MX22,MW2,Masshh2(I6G4),MCha2(I2G4))
        enddo
        enddo
        Do I6G4=1,6
        Do I2G4=1,2
        Do I2G5=1,2
       ant44(I6G4,I2G4,I2G5)=C0i(cc2,MCH2,MX22,MX12,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MCha2(I2G5))
       ant45(I6G4,I2G4,I2G5)=C0i(cc1,MCH2,MX22,MX12,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MCha2(I2G5))
       ant46(I6G4,I2G4,I2G5)=C0i(cc0,MCH2,MX22,MX12,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MCha2(I2G5))
        enddo
        enddo
        enddo
        Do I3G5=1,3
        Do I6G4=1,6
        Do I3G4=1,3
       ant51(I3G5,I6G4,I3G4)=C0i(cc1,MX22,MCH2,MX12,MFe2(I3G5)
     &  ,MSe2(I6G4),MSv2(I3G4))
       ant52(I3G5,I6G4,I3G4)=C0i(cc2,MX22,MCH2,MX12,MFe2(I3G5)
     &  ,MSe2(I6G4),MSv2(I3G4))
       ant53(I3G5,I6G4,I3G4)=C0i(cc0,MX22,MCH2,MX12,MFe2(I3G5)
     &  ,MSe2(I6G4),MSv2(I3G4))
       ant54(I3G5,I3G4,I6G4)=C0i(cc1,MCH2,MX12,MX22,MFd2(I3G5)
     &  ,MFu2(I3G4),MSd2(I6G4))
       ant55(I3G5,I3G4,I6G4)=C0i(cc2,MCH2,MX12,MX22,MFd2(I3G5)
     &  ,MFu2(I3G4),MSd2(I6G4))
       ant56(I3G4,I3G5,I6G4)=C0i(cc1,MCH2,MX22,MX12,MFd2(I3G4)
     &  ,MFu2(I3G5),MSu2(I6G4))
       ant57(I3G4,I3G5,I6G4)=C0i(cc2,MCH2,MX22,MX12,MFd2(I3G4)
     &  ,MFu2(I3G5),MSu2(I6G4))
       ant58(I3G4,I3G5,I6G4)=C0i(cc0,MCH2,MX22,MX12,MFd2(I3G4)
     &  ,MFu2(I3G5),MSu2(I6G4))
       ant59(I3G5,I3G4,I6G4)=C0i(cc0,MCH2,MX12,MX22,MFd2(I3G5)
     &  ,MFu2(I3G4),MSd2(I6G4))
        enddo
        enddo
        enddo
        Do I6G4=1,6
        Do I2G4=1,2
        Do I5G4=1,5
       ant63(I6G4,I2G4,I5G4)=C0i(cc2,MCH2,MX12,MX22,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MNeu2(I5G4))
       ant64(I6G4,I2G4,I5G4)=C0i(cc1,MCH2,MX12,MX22,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MNeu2(I5G4))
       ant65(I6G4,I2G4,I5G4)=C0i(cc0,MX12,MCH2,MX22,Masshh2(I6G4)
     &  ,MCha2(I2G4),MNeu2(I5G4))
       ant66(I6G4,I2G4,I5G4)=C0i(cc1,MX12,MCH2,MX22,Masshh2(I6G4)
     &  ,MCha2(I2G4),MNeu2(I5G4))
       ant67(I6G4,I2G4,I5G4)=C0i(cc0,MCH2,MX12,MX22,Masshh2(I6G4)
     &  ,MassHpm2(I2G4),MNeu2(I5G4))
       ant68(I6G4,I2G4,I5G4)=C0i(cc2,MX12,MCH2,MX22,Masshh2(I6G4)
     &  ,MCha2(I2G4),MNeu2(I5G4))
        enddo
        enddo
        enddo
        Do I3G4=1,3
        Do I6G5=1,6
        Do I6G4=1,6
       ant69(I3G4,I6G5,I6G4)=C0i(cc1,MX22,MCH2,MX12,MFd2(I3G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
       ant70(I3G4,I6G5,I6G4)=C0i(cc2,MX22,MCH2,MX12,MFd2(I3G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
       ant71(I3G4,I6G4,I6G5)=C0i(cc2,MX12,MCH2,MX22,MFu2(I3G4)
     &  ,MSd2(I6G4),MSu2(I6G5))
       ant72(I3G4,I6G4,I6G5)=C0i(cc1,MX12,MCH2,MX22,MFu2(I3G4)
     &  ,MSd2(I6G4),MSu2(I6G5))
       ant73(I3G4,I6G5,I6G4)=C0i(cc0,MX22,MCH2,MX12,MFd2(I3G4)
     &  ,MSd2(I6G5),MSu2(I6G4))
       ant74(I3G4,I6G4,I6G5)=C0i(cc0,MX12,MCH2,MX22,MFu2(I3G4)
     &  ,MSd2(I6G4),MSu2(I6G5))
        enddo
        enddo
        enddo
        Do I3G4=1,3
       ant75(I3G4,I3G4)=C0i(cc2,MCH2,MX12,MX22,0D0,MFe2(I3G4),MSv2(I3G4))
       ant76(I3G4,I3G4)=C0i(cc1,MCH2,MX12,MX22,0D0,MFe2(I3G4),MSv2(I3G4))
       ant77(I3G4,I3G4)=C0i(cc0,MCH2,MX12,MX22,0D0,MFe2(I3G4),MSv2(I3G4))
        enddo


        part1=0D0; part2=0D0
        i=iin;j=jin

        Do I2G4=1,2
        Do I2G5=1,2
        Do I5G4=1,5
       Part1=Part1-(IC*(MX1*MX2*ant38(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)+MX1*MX2*ant39(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)+MX1*MX2*ant40(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)+MCH2*ant38(I2G5,I2G4,I5G4)*
     &  CLHmChiCha(I2G4,j,I2G5)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant38(I2G5,I2G4,I5G4)*
     &  CLHmChiCha(I2G4,j,I2G5)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant39(I2G5,I2G4,I5G4)*
     &  CLHmChiCha(I2G4,j,I2G5)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant40(I2G5,I2G4,I5G4)*
     &  CLHmChiCha(I2G4,j,I2G5)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHpChiCha(I5G4,I2G4,2)+ant6(I2G5,I2G4)*CLHmChiCha(I2G4,j,I2G5)
     &  *CLHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)+MX1*
     &  ant39(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHpChiCha(I5G4,i,I2G5)*MCha(I2G4)+MX1*
     &  ant40(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHpChiCha(I5G4,i,I2G5)*MCha(I2G4)+MX2*
     &  ant38(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHmChiCha(I2G4,j,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+MX2*
     &  ant38(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*MNeu(I5G4)+MX2*
     &  ant40(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*MNeu(I5G4)+MX1*
     &  ant39(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+
     &  ant40(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,i,I2G5)*CLHpChiCha(I5G4,I2G4,2)*MCha(I2G4)*
     &  MNeu(I5G4)+ant40(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MNeu2(I5G4)))
       Part2=Part2-(IC*(MCH2*ant38(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)-MX12*ant38(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)-MX12*ant39(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)-MX12*ant40(I2G5,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)+ant6(I2G5,I2G4)*CLHpChiCha(I5G4,I2G4,2)
     &  *CRHmChiCha(I2G4,j,I2G5)*CRHpChiCha(I5G4,i,I2G5)+MX1*MX2*
     &  ant38(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)+MX1*MX2*
     &  ant39(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)+MX1*MX2*
     &  ant40(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)+MX2*
     &  ant38(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHpChiCha(I5G4,i,I2G5)*MCha(I2G4)+MX1*
     &  ant39(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHmChiCha(I2G4,j,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+MX1*
     &  ant40(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CRHmChiCha(I2G4,j,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+MX1*
     &  ant39(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,i,I2G5)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRHmChiCha(I2G4,j,I2G5)*MNeu(I5G4)+MX2*
     &  ant38(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+MX2*
     &  ant40(I2G5,I2G4,I5G4)*CLHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+
     &  ant40(I2G5,I2G4,I5G4)*CRHmChiCha(I2G4,j,I2G5)*
     &  CRHpChiCha(I5G4,i,I2G5)*CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)*
     &  MNeu(I5G4)+ant40(I2G5,I2G4,I5G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRHmChiCha(I2G4,j,I2G5)*CRHpChiCha(I5G4,i,I2G5)*MNeu2(I5G4)))
       enddo
       enddo
       enddo
        Do I2G4=1,2
        Do I2G5=1,2
        Do I6G4=1,6
       Part1=Part1-(IC*ChHmHp(I2G4,2,I6G4)*(MX1*ant44(I6G4,I2G4,I2G5)*
     &  CLHpChiCha(j,I2G5,I2G4)*CRhChapCham(I2G5,i,I6G4)+MX1*
     &  ant45(I6G4,I2G4,I2G5)*CLHpChiCha(j,I2G5,I2G4)*
     &  CRhChapCham(I2G5,i,I6G4)+MX1*ant46(I6G4,I2G4,I2G5)*
     &  CLHpChiCha(j,I2G5,I2G4)*CRhChapCham(I2G5,i,I6G4)-MX2*
     &  ant45(I6G4,I2G4,I2G5)*CLhChapCham(I2G5,i,I6G4)*
     &  CRHpChiCha(j,I2G5,I2G4)+ant46(I6G4,I2G4,I2G5)*
     &  CLhChapCham(I2G5,i,I6G4)*CLHpChiCha(j,I2G5,I2G4)*MCha(I2G5)))
       Part2=Part2+IC*ChHmHp(I2G4,2,I6G4)*(MX2*ant45(I6G4,I2G4,I2G5)*
     &  CLHpChiCha(j,I2G5,I2G4)*CRhChapCham(I2G5,i,I6G4)-MX1*
     &  ant44(I6G4,I2G4,I2G5)*CLhChapCham(I2G5,i,I6G4)*
     &  CRHpChiCha(j,I2G5,I2G4)-MX1*ant45(I6G4,I2G4,I2G5)*
     &  CLhChapCham(I2G5,i,I6G4)*CRHpChiCha(j,I2G5,I2G4)-MX1*
     &  ant46(I6G4,I2G4,I2G5)*CLhChapCham(I2G5,i,I6G4)*
     &  CRHpChiCha(j,I2G5,I2G4)-ant46(I6G4,I2G4,I2G5)*
     &  CRhChapCham(I2G5,i,I6G4)*CRHpChiCha(j,I2G5,I2G4)*MCha(I2G5))
       enddo
       enddo
       enddo
        Do I2G4=1,2
        Do I5G4=1,5
        Do I6G4=1,6
       Part1=Part1-(IC*(MX2*ant63(I6G4,I2G4,I5G4)*ChHmHp(I2G4,2,I6G4)*
     &  CLHpChiCha(I5G4,i,I2G4)*CRhChiChi(j,I5G4,I6G4)+MX2*
     &  ant64(I6G4,I2G4,I5G4)*ChHmHp(I2G4,2,I6G4)*
     &  CLHpChiCha(I5G4,i,I2G4)*CRhChiChi(j,I5G4,I6G4)+MX2*
     &  ant67(I6G4,I2G4,I5G4)*ChHmHp(I2G4,2,I6G4)*
     &  CLHpChiCha(I5G4,i,I2G4)*CRhChiChi(j,I5G4,I6G4)+MX1*MX2*
     &  ant65(I6G4,I2G4,I5G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)+MX1*MX2*
     &  ant66(I6G4,I2G4,I5G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)+MX1*MX2*
     &  ant68(I6G4,I2G4,I5G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)-MX1*
     &  ant64(I6G4,I2G4,I5G4)*ChHmHp(I2G4,2,I6G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CRHpChiCha(I5G4,i,I2G4)+ant11(I6G4,I5G4)
     &  *CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant66(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)+MCH2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX12*ant68(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)+MX2*ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChiChi(j,I5G4,I6G4)*MCha(I2G4)+MX2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChiChi(j,I5G4,I6G4)*MCha(I2G4)+MX1*ant66(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CRhChapCham(I2G4,i,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha2(I2G4)+ant67(I6G4,I2G4,I5G4)*
     &  ChHmHp(I2G4,2,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,i,I2G4)*MNeu(I5G4)+MX1*ant65(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*MNeu(I5G4)+MX1*ant66(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*MNeu(I5G4)+MX2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*MCha(I2G4)*MNeu(I5G4)))
       Part2=Part2+IC*(MX1*ant64(I6G4,I2G4,I5G4)*ChHmHp(I2G4,2,I6G4)*
     &  CLHpChiCha(I5G4,i,I2G4)*CRhChiChi(j,I5G4,I6G4)-ant11(I6G4,I5G4)
     &  *CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)+MX12*ant65(I6G4,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)+MX12*ant66(I6G4,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)-MCH2*ant68(I6G4,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)+MX12*ant68(I6G4,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)-MX2*ant63(I6G4,I2G4,I5G4)*
     &  ChHmHp(I2G4,2,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,i,I2G4)-MX2*ant64(I6G4,I2G4,I5G4)*
     &  ChHmHp(I2G4,2,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,i,I2G4)-MX2*ant67(I6G4,I2G4,I5G4)*
     &  ChHmHp(I2G4,2,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,i,I2G4)-MX1*MX2*ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX1*MX2*ant66(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX1*MX2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)-MX1*ant66(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChiChi(j,I5G4,I6G4)*MCha(I2G4)-MX2*ant65(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CRhChapCham(I2G4,i,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)-MX2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CRhChapCham(I2G4,i,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)-ant65(I6G4,I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRhChapCham(I2G4,i,I6G4)*
     &  CRhChiChi(j,I5G4,I6G4)*MCha2(I2G4)-MX2*ant68(I6G4,I2G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*CLHpChiCha(I5G4,I2G4,2)*
     &  CRhChapCham(I2G4,i,I6G4)*MNeu(I5G4)-ant67(I6G4,I2G4,I5G4)*
     &  ChHmHp(I2G4,2,I6G4)*CRhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,i,I2G4)*MNeu(I5G4)-MX1*ant65(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)-MX1*ant66(I6G4,I2G4,I5G4)*
     &  CLhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)-ant65(I6G4,I2G4,I5G4)*
     &  CRhChapCham(I2G4,i,I6G4)*CRhChiChi(j,I5G4,I6G4)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)*MNeu(I5G4))
       enddo
       enddo
       enddo
        Do I2G4=1,2
        Do I5G4=1,5
       Part1=Part1-2*IC*(2*ant3(I5G4)*CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)+MCH2*ant32(I2G4,I5G4)*CF11ZR(j,I5G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)-MX12*ant32(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant32(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)-MCH2*ant34(I2G4,I5G4)*CF11ZR(j,I5G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)-MX12*ant34(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant34(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)-MCH2*ant35(I2G4,I5G4)*CF11ZR(j,I5G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)-MX12*ant35(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant35(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)+MCH2*ant33(I2G4,I5G4)*CLF12F11W(I2G4,j)
     &  *CLHpChiCha(I5G4,I2G4,2)*DCONJG(CLF12F11W(i,I5G4))+MX12*
     &  ant33(I2G4,I5G4)*CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))-MX22*ant33(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))-MCH2*ant36(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))+MX12*ant36(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))-MX22*ant36(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))+MCH2*ant37(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))+MX12*ant37(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))-MX22*ant37(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))-2*ant5(I2G4)*CLF12F11W(I2G4,j)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(CLF12F11W(i,I5G4))-MX1*
     &  ant34(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)*MCha(I2G4)-MX2*ant32(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)*
     &  MCha(I2G4)-MX2*ant35(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+MX2*ant36(I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRF12F11W(I2G4,j)*
     &  DCONJG(CLF12F11W(i,I5G4))*MCha(I2G4)+MX1*ant33(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MCha(I2G4)+MX1*ant37(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MCha(I2G4)+2*ant35(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)*
     &  MCha2(I2G4)-MX2*ant32(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)-MX1*ant34(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)*
     &  MNeu(I5G4)-MX1*ant35(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+MX2*ant36(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+MX2*ant37(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+MX1*ant33(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)+2*ant35(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZL(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)*
     &  MCha(I2G4)*MNeu(I5G4)-2*ant37(I2G4,I5G4)*CLF12F11W(I2G4,j)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(CLF12F11W(i,I5G4))*MCha(I2G4)*
     &  MNeu(I5G4)-2*ant37(I2G4,I5G4)*CLF12F11W(I2G4,j)*
     &  CLHpChiCha(I5G4,I2G4,2)*DCONJG(CLF12F11W(i,I5G4))*MNeu2(I5G4))
       Part2=Part2-2*IC*(2*ant3(I5G4)*CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)+MCH2*ant32(I2G4,I5G4)*CF11ZL(j,I5G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)-MX12*ant32(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant32(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)-MCH2*ant34(I2G4,I5G4)*CF11ZL(j,I5G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)-MX12*ant34(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant34(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)-MCH2*ant35(I2G4,I5G4)*CF11ZL(j,I5G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)-MX12*ant35(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)+MX22*
     &  ant35(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)+MCH2*ant33(I2G4,I5G4)*CRF12F11W(I2G4,j)
     &  *CRHpChiCha(I5G4,I2G4,2)*DCONJG(CRF12F11W(i,I5G4))+MX12*
     &  ant33(I2G4,I5G4)*CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))-MX22*ant33(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))-MCH2*ant36(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))+MX12*ant36(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))-MX22*ant36(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))+MCH2*ant37(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))+MX12*ant37(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))-MX22*ant37(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))-2*ant5(I2G4)*CRF12F11W(I2G4,j)*
     &  CRHpChiCha(I5G4,I2G4,2)*DCONJG(CRF12F11W(i,I5G4))-MX2*
     &  ant32(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)*MCha(I2G4)-MX2*ant35(I2G4,I5G4)*
     &  CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)*
     &  MCha(I2G4)-MX1*ant34(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)*MCha(I2G4)+MX1*ant33(I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRF12F11W(I2G4,j)*
     &  DCONJG(CLF12F11W(i,I5G4))*MCha(I2G4)+MX1*ant37(I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRF12F11W(I2G4,j)*
     &  DCONJG(CLF12F11W(i,I5G4))*MCha(I2G4)+MX2*ant36(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MCha(I2G4)+2*ant35(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*CRHpChiCha(I5G4,I2G4,2)*
     &  MCha2(I2G4)-MX1*ant34(I2G4,I5G4)*CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)-MX1*ant35(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZL(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)*
     &  MNeu(I5G4)-MX2*ant32(I2G4,I5G4)*CF11ZR(j,I5G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(I5G4,I2G4,2)*MNeu(I5G4)+MX1*ant33(I2G4,I5G4)*
     &  CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+MX2*ant36(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)+MX2*ant37(I2G4,I5G4)*
     &  CLF12F11W(I2G4,j)*CLHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)+2*ant35(I2G4,I5G4)*
     &  CF11ZL(j,I5G4)*CF12ZR(I2G4,i)*CLHpChiCha(I5G4,I2G4,2)*
     &  MCha(I2G4)*MNeu(I5G4)-2*ant37(I2G4,I5G4)*
     &  CLHpChiCha(I5G4,I2G4,2)*CRF12F11W(I2G4,j)*
     &  DCONJG(CRF12F11W(i,I5G4))*MCha(I2G4)*MNeu(I5G4)-
     &  2*ant37(I2G4,I5G4)*CRF12F11W(I2G4,j)*CRHpChiCha(I5G4,I2G4,2)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu2(I5G4))
       enddo
       enddo
        Do I2G4=1,2
        Do I6G4=1,6
       Part1=Part1-(ChHpWm(I6G4,2)*(2*MX1*MX2*ant41(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))+MX1*MX2*
     &  ant42(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))+2*MX1*MX2*ant43(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))+MCH2*
     &  ant41(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))-2*MX12*ant41(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+MCH2*
     &  ant42(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))-MX12*ant42(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+MCH2*
     &  ant43(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))-MX12*ant43(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+ant5(I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+
     &  ant41(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))*Masshh2(I6G4)+2*MX2*ant41(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4)+
     &  MX2*ant42(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4)+MX2*ant43(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4)-
     &  2*MX1*ant41(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))*MCha(I2G4)-MX1*ant42(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))*MCha(I2G4)))
       Part2=Part2-(ChHpWm(I6G4,2)*(MCH2*ant41(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))-2*MX12*
     &  ant41(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))+MCH2*ant42(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))-MX12*
     &  ant42(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))+MCH2*ant43(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))-MX12*
     &  ant43(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))+ant5(I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))+2*MX1*MX2*ant41(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+MX1*MX2*
     &  ant42(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))+2*MX1*MX2*ant43(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))+
     &  ant41(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))*Masshh2(I6G4)-2*MX1*ant41(I6G4,I2G4)*
     &  CLhChapCham(I2G4,i,I6G4)*DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4)-
     &  MX1*ant42(I6G4,I2G4)*CLhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4)+2*MX2*ant41(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))*MCha(I2G4)+
     &  MX2*ant42(I6G4,I2G4)*CRhChapCham(I2G4,i,I6G4)*
     &  DCONJG(CRF12F11W(I2G4,j))*MCha(I2G4)+MX2*ant43(I6G4,I2G4)*
     &  CRhChapCham(I2G4,i,I6G4)*DCONJG(CRF12F11W(I2G4,j))*MCha(I2G4)))
       enddo
       enddo
        Do I2G4=1,2
       Part1=Part1+(-(CHpHmZ*IC*ant2(I2G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(j,I2G4,2))-2*CHpHmZ*IC*MCH2*ant23(I2G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-CHpHmZ*IC*MX12*ant23(I2G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)+2*CHpHmZ*IC*MX22*
     &  ant23(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-3*CHpHmZ*IC*
     &  MCH2*ant24(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)+CHpHmZ*IC*
     &  MX22*ant24(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-2*CHpHmZ*
     &  IC*MCH2*ant25(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)+2*
     &  CHpHmZ*IC*MX22*ant25(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-
     &  CHpHmZ*IC*MZ2*ant25(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-
     &  2*CHpHmZ*IC*MX1*MX2*ant23(I2G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(j,I2G4,2)-CHpHmZ*IC*MX1*MX2*ant24(I2G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-2*CHpHmZ*IC*MX1*MX2*
     &  ant25(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-2*MX2*
     &  ant20(I2G4)*CF12ZL(I2G4,i)*CHmWpZ(2)*DCONJG(CLF12F11W(I2G4,j))-
     &  2*MX2*ant21(I2G4)*CF12ZL(I2G4,i)*CHmWpZ(2)*
     &  DCONJG(CLF12F11W(I2G4,j))-2*MX2*ant22(I2G4)*CF12ZL(I2G4,i)*
     &  CHmWpZ(2)*DCONJG(CLF12F11W(I2G4,j))+2*MX1*ant20(I2G4)*
     &  CF12ZR(I2G4,i)*CHmWpZ(2)*DCONJG(CRF12F11W(I2G4,j))-CHpHmZ*IC*
     &  MX1*ant23(I2G4)*CF12ZR(I2G4,i)*CLHpChiCha(j,I2G4,2)*MCha(I2G4)-
     &  CHpHmZ*IC*MX1*ant24(I2G4)*CF12ZR(I2G4,i)*CLHpChiCha(j,I2G4,2)*
     &  MCha(I2G4)-2*CHpHmZ*IC*MX1*ant25(I2G4)*CF12ZR(I2G4,i)*
     &  CLHpChiCha(j,I2G4,2)*MCha(I2G4)+CHpHmZ*IC*MX2*ant24(I2G4)*
     &  CF12ZL(I2G4,i)*CRHpChiCha(j,I2G4,2)*MCha(I2G4)+2*CHpHmZ*IC*MX2*
     &  ant25(I2G4)*CF12ZL(I2G4,i)*CRHpChiCha(j,I2G4,2)*MCha(I2G4)+4*
     &  ant22(I2G4)*CF12ZL(I2G4,i)*CHmWpZ(2)*DCONJG(CRF12F11W(I2G4,j))*
     &  MCha(I2G4))
       Part2=Part2+(-2*CHpHmZ*IC*MX1*MX2*ant23(I2G4)*CF12ZL(I2G4,i)*
     &  CLHpChiCha(j,I2G4,2)-CHpHmZ*IC*MX1*MX2*ant24(I2G4)*
     &  CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-2*CHpHmZ*IC*MX1*MX2*
     &  ant25(I2G4)*CF12ZL(I2G4,i)*CLHpChiCha(j,I2G4,2)-CHpHmZ*IC*
     &  ant2(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-2*CHpHmZ*IC*
     &  MCH2*ant23(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-CHpHmZ*IC*
     &  MX12*ant23(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)+2*CHpHmZ*
     &  IC*MX22*ant23(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-3*
     &  CHpHmZ*IC*MCH2*ant24(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)+
     &  CHpHmZ*IC*MX22*ant24(I2G4)*CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-
     &  2*CHpHmZ*IC*MCH2*ant25(I2G4)*CF12ZR(I2G4,i)*
     &  CRHpChiCha(j,I2G4,2)+2*CHpHmZ*IC*MX22*ant25(I2G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)-CHpHmZ*IC*MZ2*ant25(I2G4)*
     &  CF12ZR(I2G4,i)*CRHpChiCha(j,I2G4,2)+2*MX1*ant20(I2G4)*
     &  CF12ZL(I2G4,i)*CHmWpZ(2)*DCONJG(CLF12F11W(I2G4,j))-2*MX2*
     &  ant20(I2G4)*CF12ZR(I2G4,i)*CHmWpZ(2)*DCONJG(CRF12F11W(I2G4,j))-
     &  2*MX2*ant21(I2G4)*CF12ZR(I2G4,i)*CHmWpZ(2)*
     &  DCONJG(CRF12F11W(I2G4,j))-2*MX2*ant22(I2G4)*CF12ZR(I2G4,i)*
     &  CHmWpZ(2)*DCONJG(CRF12F11W(I2G4,j))+CHpHmZ*IC*MX2*ant24(I2G4)*
     &  CF12ZR(I2G4,i)*CLHpChiCha(j,I2G4,2)*MCha(I2G4)+2*CHpHmZ*IC*MX2*
     &  ant25(I2G4)*CF12ZR(I2G4,i)*CLHpChiCha(j,I2G4,2)*MCha(I2G4)-
     &  CHpHmZ*IC*MX1*ant23(I2G4)*CF12ZL(I2G4,i)*CRHpChiCha(j,I2G4,2)*
     &  MCha(I2G4)-CHpHmZ*IC*MX1*ant24(I2G4)*CF12ZL(I2G4,i)*
     &  CRHpChiCha(j,I2G4,2)*MCha(I2G4)-2*CHpHmZ*IC*MX1*ant25(I2G4)*
     &  CF12ZL(I2G4,i)*CRHpChiCha(j,I2G4,2)*MCha(I2G4)+4*ant22(I2G4)*
     &  CF12ZR(I2G4,i)*CHmWpZ(2)*DCONJG(CLF12F11W(I2G4,j))*MCha(I2G4))
       enddo
        Do I3G4=1,3
        Do I3G5=1,3
        Do I6G4=1,6
       Part1=Part1+(-(IC*MX2*ant51(I3G5,I6G4,I3G4)*
     &  cchitaustauR(j,I3G5,I6G4)*CHpSemSv(I6G4,I3G4,2)*
     &  ctauchastauL(I3G5,i,I3G4))-IC*MX1*ant52(I3G5,I6G4,I3G4)*
     &  cchitaustauL(j,I3G5,I6G4)*CHpSemSv(I6G4,I3G4,2)*
     &  ctauchastauR(I3G5,i,I3G4)+3*MX1*MX2*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)-3*MCH2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)-3*MX12*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)-3*ant9(I3G5,I6G4)*cchiupsumL(j,I3G5,I6G4)*
     &  cdmchapsuL(I3G4,i,I6G4)*CtbHpR(I3G5,I3G4,2)+3*MX1*MX2*
     &  ant55(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))-3*
     &  ant10(I3G5,I6G4)*CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))+3*MCH2*ant54(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))+3*MCH2*ant55(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))-3*MX12*ant55(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))+3*MCH2*ant59(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))-3*MX2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)-3*MX2*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)+3*MX1*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)+3*MX1*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)+3*MX1*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)+3*MX2*ant54(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))*MassFd(I3G5)+3*MX2*
     &  ant55(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFd(I3G5)+3*MX2*ant59(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFd(I3G5)-3*MX1*ant54(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)-3*MX1*ant59(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)+IC*ant53(I3G5,I6G4,I3G4)*cchitaustauL(j,I3G5,I6G4)
     &  *CHpSemSv(I6G4,I3G4,2)*ctauchastauL(I3G5,i,I3G4)*MassFe(I3G5)+
     &  3*MX2*ant54(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFu(I3G4)+3*MX2*ant55(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFu(I3G4)-3*MX1*ant54(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFu(I3G4)-3*ant59(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)*MassFu(I3G4)+3*MX1*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFu(I3G5)+3*MX1*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFu(I3G5)-3*MX2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFu(I3G5)-3*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)*MassFu(I3G5)-3*
     &  ant58(I3G4,I3G5,I6G4)*cchiupsumL(j,I3G5,I6G4)*
     &  cdmchapsuL(I3G4,i,I6G4)*CtbHpR(I3G5,I3G4,2)*MFd2(I3G4)-3*
     &  ant59(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &   DCONJG(cchidmsdpR(j,I3G5,I6G4))*MFu2(I3G4))
       Part2=Part2+(-(IC*MX1*ant52(I3G5,I6G4,I3G4)*
     &  cchitaustauR(j,I3G5,I6G4)*CHpSemSv(I6G4,I3G4,2)*
     &  ctauchastauL(I3G5,i,I3G4))-IC*MX2*ant51(I3G5,I6G4,I3G4)*
     &  cchitaustauL(j,I3G5,I6G4)*CHpSemSv(I6G4,I3G4,2)*
     &  ctauchastauR(I3G5,i,I3G4)-3*MCH2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)-3*MX12*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)-3*ant9(I3G5,I6G4)*cchiupsumR(j,I3G5,I6G4)*
     &  cdmchapsuR(I3G4,i,I6G4)*CtbHpL(I3G5,I3G4,2)+3*MX1*MX2*
     &  ant57(I3G4,I3G5,I6G4)*cchiupsumL(j,I3G5,I6G4)*
     &  cdmchapsuL(I3G4,i,I6G4)*CtbHpR(I3G5,I3G4,2)-3*ant10(I3G5,I6G4)*
     &  CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))+3*MCH2*ant54(I3G5,I3G4,I6G4)*
     &  CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))+3*MCH2*ant55(I3G5,I3G4,I6G4)*
     &  CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))-3*MX12*ant55(I3G5,I3G4,I6G4)*
     &  CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))+3*MCH2*ant59(I3G5,I3G4,I6G4)*
     &  CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))+3*MX1*MX2*ant55(I3G5,I3G4,I6G4)
     &  *CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpR(j,I3G5,I6G4))+3*MX1*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)+3*MX1*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)+3*MX1*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFd(I3G4)-3*MX2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)-3*MX2*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)-3*MX1*ant54(I3G5,I3G4,I6G4)*
     &  CtbHpR(I3G4,I3G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchidmsdpL(j,I3G5,I6G4))*MassFd(I3G5)-3*MX1*
     &  ant59(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFd(I3G5)+3*MX2*ant54(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)+3*MX2*ant55(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)+3*MX2*ant59(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFd(I3G5)+IC*ant53(I3G5,I6G4,I3G4)*cchitaustauR(j,I3G5,I6G4)
     &  *CHpSemSv(I6G4,I3G4,2)*ctauchastauR(I3G5,i,I3G4)*MassFe(I3G5)-
     &  3*MX1*ant54(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*
     &  cupchapsdL(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFu(I3G4)+3*MX2*ant54(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFu(I3G4)+3*MX2*ant55(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpR(j,I3G5,I6G4))*
     &  MassFu(I3G4)-3*ant59(I3G5,I3G4,I6G4)*CtbHpR(I3G4,I3G5,2)*
     &  cupchapsdR(i,I3G4,I6G4)*DCONJG(cchidmsdpL(j,I3G5,I6G4))*
     &  MassFd(I3G5)*MassFu(I3G4)-3*MX2*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumL(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpL(I3G5,I3G4,2)*MassFu(I3G5)+3*MX1*ant56(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFu(I3G5)+3*MX1*ant57(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuL(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFu(I3G5)-3*ant58(I3G4,I3G5,I6G4)*
     &  cchiupsumR(j,I3G5,I6G4)*cdmchapsuR(I3G4,i,I6G4)*
     &  CtbHpR(I3G5,I3G4,2)*MassFd(I3G4)*MassFu(I3G5)-3*
     &  ant58(I3G4,I3G5,I6G4)*cchiupsumR(j,I3G5,I6G4)*
     &  cdmchapsuR(I3G4,i,I6G4)*CtbHpL(I3G5,I3G4,2)*MFd2(I3G4)-3*
     &  ant59(I3G5,I3G4,I6G4)*CtbHpL(I3G4,I3G5,2)*cupchapsdR(i,I3G4,I6G4)
     &  *DCONJG(cchidmsdpL(j,I3G5,I6G4))*MFu2(I3G4))
       enddo
       enddo
       enddo
        Do I3G4=1,3
        Do I6G4=1,6
        Do I6G5=1,6
       Part1=Part1-3*IC*(MX2*ant69(I3G4,I6G5,I6G4)*
     &  cchidmsdpR(j,I3G4,I6G5)*cdmchapsuL(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)+MX1*ant70(I3G4,I6G5,I6G4)*
     &  cchidmsdpL(j,I3G4,I6G5)*cdmchapsuR(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)+MX2*ant71(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumL(j,I3G4,I6G5))+MX1*ant72(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumR(j,I3G4,I6G5))-ant73(I3G4,I6G5,I6G4)*
     &  cchidmsdpL(j,I3G4,I6G5)*cdmchapsuL(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)*MassFd(I3G4)-ant74(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumR(j,I3G4,I6G5))*MassFu(I3G4))
       Part2=Part2-3*IC*(MX1*ant70(I3G4,I6G5,I6G4)*
     &  cchidmsdpR(j,I3G4,I6G5)*cdmchapsuL(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)+MX2*ant69(I3G4,I6G5,I6G4)*
     &  cchidmsdpL(j,I3G4,I6G5)*cdmchapsuR(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)+MX1*ant72(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdL(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumL(j,I3G4,I6G5))+MX2*ant71(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumR(j,I3G4,I6G5))-ant73(I3G4,I6G5,I6G4)*
     &  cchidmsdpR(j,I3G4,I6G5)*cdmchapsuR(I3G4,i,I6G4)*
     &  CHpSumSdm(I6G5,I6G4,2)*MassFd(I3G4)-ant74(I3G4,I6G4,I6G5)*
     &  CHpSumSdm(I6G4,I6G5,2)*cupchapsdR(i,I3G4,I6G4)*
     &  DCONJG(cchiupsumL(j,I3G4,I6G5))*MassFu(I3G4))
       enddo
       enddo
       enddo
        Do I3G4=1,3
        Do I6G4=1,6
       Part1=Part1-(IC*DCONJG(CF12F1S12(i,I3G4,I6G4))*(MX2*
     &  ant48(I6G4,I3G4)*cchinusnu(j,I3G4)*CHpSemSv(I6G4,I3G4,2)-IC*
     &  MX12*ant49(I3G4,I6G4)*CtaunuHpR(I3G4,2)*
     &  DCONJG(cchitaustauR(j,I3G4,I6G4))-IC*MCH2*ant50(I3G4,I6G4)*
     &  CtaunuHpR(I3G4,2)*DCONJG(cchitaustauR(j,I3G4,I6G4))-IC*
     &  ant8(I3G4,I6G4)*CtaunuHpR(I3G4,2)*
     &  DCONJG(cchitaustauR(j,I3G4,I6G4))-IC*MX2*ant50(I3G4,I6G4)*
     &  CtaunuHpR(I3G4,2)*DCONJG(cchitaustauL(j,I3G4,I6G4))*MassFe(I3G4)))
       Part2=Part2+MX1*DCONJG(CF12F1S12(i,I3G4,I6G4))*(-(IC*
     &  ant47(I6G4,I3G4)*cchinusnu(j,I3G4)*CHpSemSv(I6G4,I3G4,2))+MX2*
     &  ant49(I3G4,I6G4)*CtaunuHpR(I3G4,2)*
     &  DCONJG(cchitaustauR(j,I3G4,I6G4))+ant49(I3G4,I6G4)*
     &  CtaunuHpR(I3G4,2)*DCONJG(cchitaustauL(j,I3G4,I6G4))*
     &  MassFe(I3G4)+ant50(I3G4,I6G4)*CtaunuHpR(I3G4,2)*
     &  DCONJG(cchitaustauL(j,I3G4,I6G4))*MassFe(I3G4))
       enddo
       enddo
        Do I3G4=1,3
       Part1=Part1-((CtaunuHpR(I3G4,2)*(ant13(I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)-MCH2*ant75(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)+MX12*ant75(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)-MCH2*ant76(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)-MCH2*ant77(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)+MX1*ant76(I3G4,I3G4)*
     &  ctauchastauR(I3G4,i,I3G4)*MassFe(I3G4)+ant77(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)*MFe2(I3G4))*(g1*ZNC(j,1)-g2*ZNC(j,2))
     &  )/Sqrt2)
       Part2=Part2+(MX2*CtaunuHpR(I3G4,2)*(MX1*ant75(I3G4,I3G4)*
     &  ctauchastauL(I3G4,i,I3G4)+ant75(I3G4,I3G4)*
     &  ctauchastauR(I3G4,i,I3G4)*MassFe(I3G4)+ant76(I3G4,I3G4)*
     &  ctauchastauR(I3G4,i,I3G4)*MassFe(I3G4))*(g1*ZNC(j,1)-g2*
     &  ZNC(j,2)))/Sqrt2
       enddo
        Do I5G4=1,5
        Do I6G4=1,6
       Part1=Part1+ChHpWm(I6G4,2)*(ant11(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+3*MCH2*
     &  ant60(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))-MX22*ant60(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+2*MCH2*
     &  ant61(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))+MW2*ant61(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))-2*MX22*
     &  ant61(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))+2*MCH2*ant62(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+MX12*
     &  ant62(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))-2*MX22*ant62(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+MX1*MX2*
     &  ant60(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))+2*MX1*MX2*ant61(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))+2*MX1*MX2*
     &  ant62(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))-MX2*ant60(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)-2*
     &  MX2*ant61(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+MX1*ant60(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)+2*
     &  MX1*ant61(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)+MX1*ant62(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4))
       Part2=Part2+ChHpWm(I6G4,2)*(MX1*MX2*ant60(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+2*MX1*MX2*
     &  ant61(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))+2*MX1*MX2*ant62(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))+
     &  ant11(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))+3*MCH2*ant60(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))-MX22*
     &  ant60(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))+2*MCH2*ant61(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))+MW2*
     &  ant61(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))-2*MX22*ant61(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))+2*MCH2*
     &  ant62(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))+MX12*ant62(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))-2*MX22*
     &  ant62(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))+MX1*ant60(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+2*
     &  MX1*ant61(I6G4,I5G4)*CRhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)+MX1*ant62(I6G4,I5G4)*
     &  CRhChiChi(j,I5G4,I6G4)*DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4)-
     &  MX2*ant60(I6G4,I5G4)*CLhChiChi(j,I5G4,I6G4)*
     &  DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4)-2*MX2*ant61(I6G4,I5G4)*
     &  CLhChiChi(j,I5G4,I6G4)*DCONJG(CRF12F11W(i,I5G4))*MNeu(I5G4))
       enddo
       enddo
        Do I5G4=1,5
       Part1=Part1+(CHpHmZ*IC*MCH2*ant29(I5G4)*CF11ZR(j,I5G4)*
     &  CLHpChiCha(I5G4,i,2)-CHpHmZ*IC*MX12*ant29(I5G4)*CF11ZR(j,I5G4)*
     &  CLHpChiCha(I5G4,i,2)+CHpHmZ*IC*ant3(I5G4)*CF11ZR(j,I5G4)*
     &  CLHpChiCha(I5G4,i,2)+2*CHpHmZ*IC*MCH2*ant30(I5G4)*
     &  CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)-2*CHpHmZ*IC*MX12*
     &  ant30(I5G4)*CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)+CHpHmZ*IC*MCH2*
     &  ant31(I5G4)*CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)-CHpHmZ*IC*MX12*
     &  ant31(I5G4)*CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)+CHpHmZ*IC*MX1*
     &  MX2*ant29(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)+2*CHpHmZ*
     &  IC*MX1*MX2*ant30(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)+2*
     &  CHpHmZ*IC*MX1*MX2*ant31(I5G4)*CF11ZL(j,I5G4)*
     &  CRHpChiCha(I5G4,i,2)+2*MX2*ant27(I5G4)*CF11ZL(j,I5G4)*CHmWpZ(2)
     &  *DCONJG(CLF12F11W(i,I5G4))-2*MX1*ant26(I5G4)*CF11ZR(j,I5G4)*
     &  CHmWpZ(2)*DCONJG(CRF12F11W(i,I5G4))-2*MX1*ant27(I5G4)*
     &  CF11ZR(j,I5G4)*CHmWpZ(2)*DCONJG(CRF12F11W(i,I5G4))-2*MX1*
     &  ant28(I5G4)*CF11ZR(j,I5G4)*CHmWpZ(2)*DCONJG(CRF12F11W(i,I5G4))+
     &  CHpHmZ*IC*MX2*ant29(I5G4)*CF11ZL(j,I5G4)*CLHpChiCha(I5G4,i,2)*
     &  MNeu(I5G4)+2*CHpHmZ*IC*MX2*ant30(I5G4)*CF11ZL(j,I5G4)*
     &  CLHpChiCha(I5G4,i,2)*MNeu(I5G4)+CHpHmZ*IC*MX2*ant31(I5G4)*
     &  CF11ZL(j,I5G4)*CLHpChiCha(I5G4,i,2)*MNeu(I5G4)-CHpHmZ*IC*MX1*
     &  ant29(I5G4)*CF11ZR(j,I5G4)*CRHpChiCha(I5G4,i,2)*MNeu(I5G4)-2*
     &  CHpHmZ*IC*MX1*ant30(I5G4)*CF11ZR(j,I5G4)*CRHpChiCha(I5G4,i,2)*
     &  MNeu(I5G4)+4*ant28(I5G4)*CF11ZR(j,I5G4)*CHmWpZ(2)*
     &  DCONJG(CLF12F11W(i,I5G4))*MNeu(I5G4))
       Part2=Part2+(CHpHmZ*IC*MX1*MX2*ant29(I5G4)*CF11ZR(j,I5G4)*
     &  CLHpChiCha(I5G4,i,2)+2*CHpHmZ*IC*MX1*MX2*ant30(I5G4)*
     &  CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)+2*CHpHmZ*IC*MX1*MX2*
     &  ant31(I5G4)*CF11ZR(j,I5G4)*CLHpChiCha(I5G4,i,2)+CHpHmZ*IC*MCH2*
     &  ant29(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)-CHpHmZ*IC*MX12*
     &  ant29(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)+CHpHmZ*IC*
     &  ant3(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)+2*CHpHmZ*IC*
     &  MCH2*ant30(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)-2*CHpHmZ*
     &  IC*MX12*ant30(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)+CHpHmZ*
     &  IC*MCH2*ant31(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)-CHpHmZ*
     &  IC*MX12*ant31(I5G4)*CF11ZL(j,I5G4)*CRHpChiCha(I5G4,i,2)-2*MX1*
     &  ant26(I5G4)*CF11ZL(j,I5G4)*CHmWpZ(2)*DCONJG(CLF12F11W(i,I5G4))-
     &  2*MX1*ant27(I5G4)*CF11ZL(j,I5G4)*CHmWpZ(2)*
     &  DCONJG(CLF12F11W(i,I5G4))-2*MX1*ant28(I5G4)*CF11ZL(j,I5G4)*
     &  CHmWpZ(2)*DCONJG(CLF12F11W(i,I5G4))+2*MX2*ant27(I5G4)*
     &  CF11ZR(j,I5G4)*CHmWpZ(2)*DCONJG(CRF12F11W(i,I5G4))-CHpHmZ*IC*
     &  MX1*ant29(I5G4)*CF11ZL(j,I5G4)*CLHpChiCha(I5G4,i,2)*MNeu(I5G4)-
     &  2*CHpHmZ*IC*MX1*ant30(I5G4)*CF11ZL(j,I5G4)*CLHpChiCha(I5G4,i,2)
     &  *MNeu(I5G4)+CHpHmZ*IC*MX2*ant29(I5G4)*CF11ZR(j,I5G4)*
     &  CRHpChiCha(I5G4,i,2)*MNeu(I5G4)+2*CHpHmZ*IC*MX2*ant30(I5G4)*
     &  CF11ZR(j,I5G4)*CRHpChiCha(I5G4,i,2)*MNeu(I5G4)+CHpHmZ*IC*MX2*
     &  ant31(I5G4)*CF11ZR(j,I5G4)*CRHpChiCha(I5G4,i,2)*MNeu(I5G4)+4*
     &  ant28(I5G4)*CF11ZL(j,I5G4)*CHmWpZ(2)*DCONJG(CRF12F11W(i,I5G4))*
     &  MNeu(I5G4))
       enddo
       Part1=Part1+e*(-(ant1*e*IC*CLHpChiCha(j,i,2))-2*ant17*e*IC*MCH2*
     &  CLHpChiCha(j,i,2)-3*ant18*e*IC*MCH2*CLHpChiCha(j,i,2)-2*ant19*
     &  e*IC*MCH2*CLHpChiCha(j,i,2)-2*ant17*e*IC*MX12*CLHpChiCha(j,i,2)
     &  -ant18*e*IC*MX12*CLHpChiCha(j,i,2)-2*ant19*e*IC*MX12*
     &  CLHpChiCha(j,i,2)+2*ant17*e*IC*MX22*CLHpChiCha(j,i,2)+ant18*e*
     &  IC*MX22*CLHpChiCha(j,i,2)+2*ant19*e*IC*MX22*CLHpChiCha(j,i,2)-
     &  2*ant19*e*IC*MX1*MX2*CRHpChiCha(j,i,2)-2*ant16*MX2*CHmWpA(2)*
     &  DCONJG(CLF12F11W(i,j))-2*ant14*MX1*CHmWpA(2)*
     &  DCONJG(CRF12F11W(i,j))+2*ant15*MX1*CHmWpA(2)*
     &  DCONJG(CRF12F11W(i,j))+2*ant16*MX1*CHmWpA(2)*
     &  DCONJG(CRF12F11W(i,j)))
       Part2=Part2+e*(-2*ant19*e*IC*MX1*MX2*CLHpChiCha(j,i,2)-ant1*e*
     &  IC*CRHpChiCha(j,i,2)-2*ant17*e*IC*MCH2*CRHpChiCha(j,i,2)-3*
     &  ant18*e*IC*MCH2*CRHpChiCha(j,i,2)-2*ant19*e*IC*MCH2*
     &  CRHpChiCha(j,i,2)-2*ant17*e*IC*MX12*CRHpChiCha(j,i,2)-ant18*e*
     &  IC*MX12*CRHpChiCha(j,i,2)-2*ant19*e*IC*MX12*CRHpChiCha(j,i,2)+
     &  2*ant17*e*IC*MX22*CRHpChiCha(j,i,2)+ant18*e*IC*MX22*
     &  CRHpChiCha(j,i,2)+2*ant19*e*IC*MX22*CRHpChiCha(j,i,2)-2*ant14*
     &  MX1*CHmWpA(2)*DCONJG(CLF12F11W(i,j))+2*ant15*MX1*CHmWpA(2)*
     &  DCONJG(CLF12F11W(i,j))+2*ant16*MX1*CHmWpA(2)*
     &  DCONJG(CLF12F11W(i,j))-2*ant16*MX2*CHmWpA(2)*
     &  DCONJG(CRF12F11W(i,j)))

        part1=part1*fac;part2=part2*fac
        dCW1= - SW/CW* dSW1
        dg1= (e*dZe1/CW - e*dCW1/CW**2)
        dg2= (e*dZe1/SW - e*dSW1/SW**2)
        dZCHiggs(2,2)=     dZCH()
        dZCHW=SelfHpWm()
        CTERMSL=(-(dg2*CONJG(NN(j,3))*CONJG(UM(i,1))*ZP(2,1))
     -      + CONJG(UM(i,2))*((dg1*CONJG(NN(j,1))*ZP(2,1))/
     -      Sqrt2 + (dg2*CONJG(NN(j,2))*ZP(2,1))/Sqrt2 - 
     -      expeta*dlambda1*CONJG(NN(j,5))*ZP(2,2)))
        CTERMSR=-0.5D0*(2*CONJG(dlambda1)*NN(j,5)*UP(i,2)*ZP(2,1) 
     -      + expeta*(2*dg2*NN(j,4)*UP(i,1)+Sqrt2*
     -      (dg1*NN(j,1) + dg2*NN(j,2))*UP(i,2))*ZP(2,2))

        CTERMSL =CTERMSL  + treeL*dZCHiggs(2,2)/2D0
     &           -IC*CLHpChiCha(jin,iin,1)*dZCHiggs(1,2)/2D0
        CTERMSR =CTERMSR  + treeR*dZCHiggs(2,2)/2D0
     &           -IC*CRHpChiCha(jin,iin,1)*dZCHiggs(1,2)/2D0


        do i=1,2
        CTERMSL =CTERMSL  -IC*CLHpChiCha(jin,i,2)*(dZchaL(i,iin)/2D0)  
        CTERMSR =CTERMSR  -IC*CRHpChiCha(jin,i,2)*(dZchaR(i,iin)/2D0)  
        enddo
        do i=1,5
        CTERMSL =CTERMSL  -IC*CLHpChiCha(i,iin,2)*(dZNeuRb(jin,i)/2D0)  
        CTERMSR =CTERMSR  -IC*CRHpChiCha(i,iin,2)*(dZNeuLb(jin,i)/2D0) 
        enddo

c CHW mixing
        CTERMSL =CTERMSL  +(MX2* DCONJG(CLF12F11W(iin,jin))-
     &                      MX1*DCONJG(CRF12F11W(iin,jin)) )*dZCHW/MW2

        CTERMSR =CTERMSR  -(MX1* DCONJG(CLF12F11W(iin,jin))-
     &                      MX2*DCONJG(CRF12F11W(iin,jin)))*dZCHW/MW2
 
		part1=part1+CTERMSL
		part2=part2+CTERMSR


        Cloop=2*DBLE(-2D0*MX1*MX2*TreeL*DCONJG(part2)
     &   -2D0*MX1*MX2*TreeR*DCONJG(part1)+
     &   (MCH2-MX12-MX22)*(TreeL*DCONJG(part1)+TreeR*DCONJG(part2)))

        virtEW= Cloop*RPhaseSpace2

        MA=Getlambda();
        call IBFunc(FBI,MHp,MX1,MX2,mA)
       abrx(1)=-2*e**2*(abs(treeL)**2+abs(treeR)**2)
       abrx(2)=4*e**2*(2*MX1*MX2*abs(2*treeL*DCONJG(treeR))-(MCH2-
     &  MX12-MX22)*(abs(treeL)**2+abs(treeR)**2))
       abrx(3)=4*e**2*(2*MX1*MX2*abs(2*treeL*DCONJG(treeR))-(MCH2-
     &  MX12-MX22)*(abs(treeL)**2+abs(treeR)**2))
       abrx(4)=4*e**2*MCH2*(2*MX1*MX2*abs(2*treeL*DCONJG(treeR))-
     &  (MCH2-MX12-MX22)*(abs(treeL)**2+abs(treeR)**2))
       abrx(5)=4*e**2*MX12*(2*MX1*MX2*abs(2*treeL*DCONJG(treeR))-
     &  (MCH2-MX12-MX22)*(abs(treeL)**2+abs(treeR)**2))
       abrx(6)=-4*e**2*(MCH2+MX12-MX22)*(-2*MX1*MX2*abs(2*treeL*DCONJG(treeR))
     &  +(MCH2-MX12-MX22)*(abs(treeL)**2+abs(treeR)**2))
       realPart=abrx(1)*FBI(0,0,0,0)+abrx(2)*FBI(1,0,0,0)+
     &  abrx(4)*FBI(1,1,0,0)+abrx(6)*FBI(1,2,0,0)+abrx(3)*
     &  FBI(2,0,0,0)+abrx(1)*FBI(2,0,1,0)+abrx(5)*
     &  FBI(2,2,0,0)
        realPart=realpart/64D0/MHpm/pi**3 
        awidth = treepart+virtew+realpart
c#define details
#ifdef details
        print*, "==============EW part============="
        print*, "decay: H+ -> Cha[",iin, "] + Chi[ ", jin,"]"
        print*, "dZchaL(1:2,iin)=",dZchaL(1:2,iin)
        print*, "dZchaR(1:2,iin)=",dZchaR(1:2,iin)
        print*, "dZchaLb(iin,1:2)=",dZchaLb(iin,1:2)
        print*, "dZchaRb(iin,1:2)=",dZchaRb(iin,1:2)
        print*, "dZNeuRb(jin,1:5)=",dZNeuRb(jin,1:5)
        print*, "dZNeuLb(jin,1:5)=",dZNeuLb(jin,1:5)


        print*, "dZNeuR(1:5,jin)=",dZNeuR(1:5,jin)
        print*, "dZNeuL(1:5,jin)=",dZNeuL(1:5,jin)
        print*, "dZCHW=",dZCHW
        print*, "treeL,treeR",treeL,treeR
        print*, "part1,part2",part1,part2
        print*, "NN",NN(2,1:5)
        print*, "Up",Up(2,1:2),UM(2,1:2)
        print*, "treepart=",treepart
        print*, "virtew=",virtew
        print*, "realpart=",realpart
        print*, "SUM=",realpart+virtew
		print*, "correction", (realpart+virtew)/treepart
        if( (realpart+virtew)/treepart .gt.1d0 )then
         stop
        endif
#endif

        if( abs((realpart+virtew)/treepart) .gt.0.8d0 )then
         rcheck= abs(g2*(-CONJG(NN(jin,3))*CONJG(UM(iin,1)) 
     -    +CONJG(UM(iin,2))*CONJG(NN(jin,2))/Sqrt(2d0))
     -    /(CONJG(UM(iin,2))*g1*CONJG(NN(jin,1))/Sqrt(2d0)))
         print*, "===============Warning  =============="
         print*, "decay: H+ -> Cha[",iin, "] + Chi[ ", jin,"]"
         print*, "Large NLO correction=",(realpart+virtew)/treepart*100, "[%]"
         if (0.5d0 .lt. rcheck .and.  1.5d0 .gt. rcheck)then
         print*, "due to the suppression of the tree-level coupling"
         endif
         if (jin.gt.1)then
         demass1= MNeu(jin)-MNeu(jin-1)
          if (demass1.lt.10) then
           print*, "degenerate neutrino masses, demass1=MNeu(",jin,")-MNeu(",jin-1,")=",demass1
          endif           
         endif
         demass2= MNeu(jin+1)-MNeu(jin)
         if (demass2.lt.10) then
           print*, "degenerate neutrino masses, demass2=MNeu(",jin+1,")-MNeu(",jin,")=",demass2
         endif  
         print*, "suggestion: try to change the renormalization scheme for the electroweakino sector."
        endif
        endif
        
        end subroutine Delta_CHchaneuEW


